import os
import sys

from pydbus import SystemBus
from gi.repository import GLib

loop = GLib.MainLoop()

class StarterObject(object):
    dbus = '''
    <node>
        <interface name='org.redos.edu.pydbus.Starter'>
            <method name='start'/>  
            <method name='stop'/>
            <method name='rules_tmp_firebird'/>
            <method name='quit'/>
            <method name='set_acl_firebird'>
                <arg type='s' name='username' direction='in'/>
            </method>
            <method name='rules_bash'/>
            <method name='kill_load_screen'/>
        </interface>
    </node>
    '''

    def rules_tmp_firebird(self):
        os.system("kill -9 $(ps aux | grep '[r]edos_store.py' | awk '{print $2}')")
        os.system("/opt/redos_education/rules.sh")

    def rules_bash(self):
        os.system("/opt/redos_education/rules.sh")

    def set_acl_firebird(self, username):
        os.system("sudo -u firebird mkdir -p /tmp/firebird")
        os.system("sudo -u firebird touch /tmp/firebird/fb_init")
        os.system("chown firebird. -R /tmp/firebird")
        os.system("chmod 770 -R /tmp/firebird")
        os.system(f"setfacl -R -m user:{username}:rwx /tmp/firebird")
        os.system(f"setfacl -R -m user:firebird:rwx /tmp/firebird")
        os.system(f"setfacl -R -m group:firebird:rwx /tmp/firebird")

    def kill_load_screen(self):
        os.system("kill -9 $(ps aux | grep '[z]enity --progress --pulsate' | awk '{print $2}')")

    def start(self):
        """removes this object from the DBUS connection and exits"""
        os.system("systemctl start redos-edu-dbus.service")

    def stop(self):
        """removes this object from the DBUS connection and exits"""
        os.system("systemctl stop redos-edu-dbus.service")

    def quit(self):
        loop.quit()

if __name__ == "__main__":
    if len(sys.argv) == 1:
        with SystemBus() as bus:
            with bus.publish("org.redos.edu.pydbus.Starter", StarterObject()):
                loop.run()
    elif len(sys.argv) > 1:
        if sys.argv[1] == "--start":
            with SystemBus() as bus:
                with bus.publish("org.redos.edu.pydbus.Starter", StarterObject()):
                    loop.run()
        elif sys.argv[1] == "--stop":
            os.system("rm -rf /tmp/firebird")
            loop.quit()