import math
import os
import sys
import threading

import fdb

fdb.load_api('/opt/redos_education/rdb/lib/libfbclient.so.3.0.18')

#ported to new DB
def get_groups(groups, current_page, is_group_page=False):
    # con = fdb.connect(dsn='/usr/share/redos_education/db/rpm-lists.fdb', user='sysdba', password='masterkey')
    con = fdb.connect(dsn='/opt/redos_education/rdb/db/rpm-lists.fdb', user='sysdba', password='masterkey')
    # con = fdb.connect(dsn='/opt/redstore_web/rpm-lists.fdb', user='sysdba', password='masterkey')

    cur = con.cursor()
    keys = (
        "PACKAGE_NAME", "S_DESC_ENG", "S_DESC_RU", "F_DESC_ENG", "F_DESC_RU",
        "GROUP", "ICON", "ROWSTRIDE_ICON", "HEIGHT_ICON", "WIDTH_ICON", "ALPHA_IC", "BITS_IC",
        "PICTURE1", "ROWSTRIDE_PIC1", "HEIGHT_PIC1", "WIDTH_PIC1", "ALPHA_PIC1", "BITS_PIC1",
        "PICTURE2", "ROWSTRIDE_PIC2", "HEIGHT_PIC2", "WIDTH_PIC2", "ALPHA_PIC2", "BITS_PIC2",
        "PICTURE3", "ROWSTRIDE_PIC3", "HEIGHT_PIC3", "WIDTH_PIC3", "ALPHA_PIC3", "BITS_PIC3",
        "GROUP_NAME", "GROUP_NAME_ENG", "APP_HUMANNAME")
    where = ""
    for i in range(0, len(groups)):
        where += f"(REDSTORE_GROUPS.ID = REDSTORE_RPMS.APPGROUP_ID and REDSTORE_GROUPS.GROUP_NAME='{groups[i]}') OR " \
            if i < len(groups)-1 else f"(REDSTORE_GROUPS.GROUP_NAME='{groups[i]}' and REDSTORE_GROUPS.ID = REDSTORE_RPMS.APPGROUP_ID)"
    query = f"select count(*) from REDSTORE_RPMS, REDSTORE_GROUPS  where {where}"
    cur.execute(query)
    result = cur.fetchall()[0][0]
    if not is_group_page:
        if result > 25:
            skip = 25 * current_page
            query = f"select FIRST 25 SKIP {skip} " \
                    f"REDSTORE_RPMS.PACKAGE_NAME, REDSTORE_RPMS.S_DESC_ENG, REDSTORE_RPMS.S_DESC_RU, REDSTORE_RPMS.F_DESC_ENG, REDSTORE_RPMS.F_DESC_RU, \
    REDSTORE_GROUPS.GROUP_NAME, REDSTORE_RPMS.ICON, REDSTORE_RPMS.ROWSTRIDE_ICON, REDSTORE_RPMS.HEIGHT_ICON, REDSTORE_RPMS.WIDTH_ICON, REDSTORE_RPMS.ALPHA_IC, REDSTORE_RPMS.BITS_IC, \
    REDSTORE_RPMS.PICTURE1, REDSTORE_RPMS.ROWSTRIDE_PIC1, REDSTORE_RPMS.HEIGHT_PIC1, REDSTORE_RPMS.WIDTH_PIC1, REDSTORE_RPMS.ALPHA_PIC1, REDSTORE_RPMS.BITS_PIC1, \
    REDSTORE_RPMS.PICTURE2, REDSTORE_RPMS.ROWSTRIDE_PIC2, REDSTORE_RPMS.HEIGHT_PIC2, REDSTORE_RPMS.WIDTH_PIC2, REDSTORE_RPMS.ALPHA_PIC2, REDSTORE_RPMS.BITS_PIC2, \
    REDSTORE_RPMS.PICTURE3, REDSTORE_RPMS.ROWSTRIDE_PIC3, REDSTORE_RPMS.HEIGHT_PIC3, REDSTORE_RPMS.WIDTH_PIC3, REDSTORE_RPMS.ALPHA_PIC3, REDSTORE_RPMS.BITS_PIC3, \
    REDSTORE_GROUPS.GROUP_HUMAN_NAME, REDSTORE_GROUPS.GROUP_HUMAN_NAME_ENG, REDSTORE_RPMS.HUMANNAME " \
                    f"from REDSTORE_RPMS, REDSTORE_GROUPS where {where} ORDER BY lower(REDSTORE_RPMS.PACKAGE_NAME)"
        else:
            query = f"select REDSTORE_RPMS.PACKAGE_NAME, REDSTORE_RPMS.S_DESC_ENG, REDSTORE_RPMS.S_DESC_RU, REDSTORE_RPMS.F_DESC_ENG, REDSTORE_RPMS.F_DESC_RU, \
    REDSTORE_GROUPS.GROUP_NAME, REDSTORE_RPMS.ICON, REDSTORE_RPMS.ROWSTRIDE_ICON, REDSTORE_RPMS.HEIGHT_ICON, REDSTORE_RPMS.WIDTH_ICON, REDSTORE_RPMS.ALPHA_IC, REDSTORE_RPMS.BITS_IC, \
    REDSTORE_RPMS.PICTURE1, REDSTORE_RPMS.ROWSTRIDE_PIC1, REDSTORE_RPMS.HEIGHT_PIC1, REDSTORE_RPMS.WIDTH_PIC1, REDSTORE_RPMS.ALPHA_PIC1, REDSTORE_RPMS.BITS_PIC1, \
    REDSTORE_RPMS.PICTURE2, REDSTORE_RPMS.ROWSTRIDE_PIC2, REDSTORE_RPMS.HEIGHT_PIC2, REDSTORE_RPMS.WIDTH_PIC2, REDSTORE_RPMS.ALPHA_PIC2, REDSTORE_RPMS.BITS_PIC2, \
    REDSTORE_RPMS.PICTURE3, REDSTORE_RPMS.ROWSTRIDE_PIC3, REDSTORE_RPMS.HEIGHT_PIC3, REDSTORE_RPMS.WIDTH_PIC3, REDSTORE_RPMS.ALPHA_PIC3, REDSTORE_RPMS.BITS_PIC3, \
    REDSTORE_GROUPS.GROUP_HUMAN_NAME, REDSTORE_GROUPS.GROUP_HUMAN_NAME_ENG, REDSTORE_RPMS.HUMANNAME " \
                    f"from REDSTORE_RPMS, REDSTORE_GROUPS " \
                    f"where {where} ORDER BY lower(REDSTORE_RPMS.PACKAGE_NAME)"
    else:
        if result > 24:
            skip = 24 * current_page
            query = f"select FIRST 24 SKIP {skip} " \
                    f"REDSTORE_RPMS.PACKAGE_NAME, REDSTORE_RPMS.S_DESC_ENG, REDSTORE_RPMS.S_DESC_RU, REDSTORE_RPMS.F_DESC_ENG, REDSTORE_RPMS.F_DESC_RU, \
    REDSTORE_GROUPS.GROUP_NAME, REDSTORE_RPMS.ICON, REDSTORE_RPMS.ROWSTRIDE_ICON, REDSTORE_RPMS.HEIGHT_ICON, REDSTORE_RPMS.WIDTH_ICON, REDSTORE_RPMS.ALPHA_IC, REDSTORE_RPMS.BITS_IC, \
    REDSTORE_RPMS.PICTURE1, REDSTORE_RPMS.ROWSTRIDE_PIC1, REDSTORE_RPMS.HEIGHT_PIC1, REDSTORE_RPMS.WIDTH_PIC1, REDSTORE_RPMS.ALPHA_PIC1, REDSTORE_RPMS.BITS_PIC1, \
    REDSTORE_RPMS.PICTURE2, REDSTORE_RPMS.ROWSTRIDE_PIC2, REDSTORE_RPMS.HEIGHT_PIC2, REDSTORE_RPMS.WIDTH_PIC2, REDSTORE_RPMS.ALPHA_PIC2, REDSTORE_RPMS.BITS_PIC2, \
    REDSTORE_RPMS.PICTURE3, REDSTORE_RPMS.ROWSTRIDE_PIC3, REDSTORE_RPMS.HEIGHT_PIC3, REDSTORE_RPMS.WIDTH_PIC3, REDSTORE_RPMS.ALPHA_PIC3, REDSTORE_RPMS.BITS_PIC3, \
    REDSTORE_GROUPS.GROUP_HUMAN_NAME, REDSTORE_GROUPS.GROUP_HUMAN_NAME_ENG, REDSTORE_RPMS.HUMANNAME " \
                    f"from REDSTORE_RPMS, REDSTORE_GROUPS " \
                    f"where {where} ORDER BY lower(REDSTORE_RPMS.PACKAGE_NAME)"
        else:
            query = f"select REDSTORE_RPMS.PACKAGE_NAME, REDSTORE_RPMS.S_DESC_ENG, REDSTORE_RPMS.S_DESC_RU, REDSTORE_RPMS.F_DESC_ENG, REDSTORE_RPMS.F_DESC_RU, \
    REDSTORE_GROUPS.GROUP_NAME, REDSTORE_RPMS.ICON, REDSTORE_RPMS.ROWSTRIDE_ICON, REDSTORE_RPMS.HEIGHT_ICON, REDSTORE_RPMS.WIDTH_ICON, REDSTORE_RPMS.ALPHA_IC, REDSTORE_RPMS.BITS_IC, \
    REDSTORE_RPMS.PICTURE1, REDSTORE_RPMS.ROWSTRIDE_PIC1, REDSTORE_RPMS.HEIGHT_PIC1, REDSTORE_RPMS.WIDTH_PIC1, REDSTORE_RPMS.ALPHA_PIC1, REDSTORE_RPMS.BITS_PIC1, \
    REDSTORE_RPMS.PICTURE2, REDSTORE_RPMS.ROWSTRIDE_PIC2, REDSTORE_RPMS.HEIGHT_PIC2, REDSTORE_RPMS.WIDTH_PIC2, REDSTORE_RPMS.ALPHA_PIC2, REDSTORE_RPMS.BITS_PIC2, \
    REDSTORE_RPMS.PICTURE3, REDSTORE_RPMS.ROWSTRIDE_PIC3, REDSTORE_RPMS.HEIGHT_PIC3, REDSTORE_RPMS.WIDTH_PIC3, REDSTORE_RPMS.ALPHA_PIC3, REDSTORE_RPMS.BITS_PIC3, \
    REDSTORE_GROUPS.GROUP_HUMAN_NAME, REDSTORE_GROUPS.GROUP_HUMAN_NAME_ENG, REDSTORE_RPMS.HUMANNAME " \
                    f"from REDSTORE_RPMS, REDSTORE_GROUPS " \
                    f"where {where} ORDER BY lower(REDSTORE_RPMS.PACKAGE_NAME)"
    cur.execute(query)
    packs = list(cur.fetchall())
    for i in range(0, len(packs)):
        packs[i] = list(packs[i])
        for j in range(0, len(packs[i])):
            if type(packs[i][j]) == fdb.fbcore.BlobReader:
                blob = packs[i][j].read(-1)
                packs[i][j].close()
                packs[i][j] = blob
        packs[i] = {k: v for k, v in zip(keys, packs[i])}
    con.close()
    max_pages = math.ceil(result / 25) if not is_group_page else math.ceil(result / 24)
    return [packs, result, max_pages]

#ported to new DB
def get_search(search_text, groups, current_page):
    # con = fdb.connect(dsn='/usr/share/redos_education/db/rpm-lists.fdb', user='sysdba', password='masterkey')
    con = fdb.connect(dsn='/opt/redos_education/rdb/db/rpm-lists.fdb', user='sysdba', password='masterkey')
    # con = fdb.connect(dsn='/opt/redstore_web/rpm-lists.fdb', user='sysdba', password='masterkey')

    cur = con.cursor()
    keys = (
        "PACKAGE_NAME", "S_DESC_ENG", "S_DESC_RU", "F_DESC_ENG", "F_DESC_RU",
        "GROUP", "ICON", "ROWSTRIDE_ICON", "HEIGHT_ICON", "WIDTH_ICON", "ALPHA_IC", "BITS_IC",
        "PICTURE1", "ROWSTRIDE_PIC1", "HEIGHT_PIC1", "WIDTH_PIC1", "ALPHA_PIC1", "BITS_PIC1",
        "PICTURE2", "ROWSTRIDE_PIC2", "HEIGHT_PIC2", "WIDTH_PIC2", "ALPHA_PIC2", "BITS_PIC2",
        "PICTURE3", "ROWSTRIDE_PIC3", "HEIGHT_PIC3", "WIDTH_PIC3", "ALPHA_PIC3", "BITS_PIC3",
        "GROUP_NAME", "GROUP_NAME_ENG", "APP_HUMANNAME"
    )
    where = ""
    for i in range(0, len(groups)):
        where += \
            f"(REDSTORE_GROUPS.ID = REDSTORE_RPMS.APPGROUP_ID and REDSTORE_GROUPS.GROUP_NAME='{groups[i]}' AND " \
            f"(REDSTORE_RPMS.PACKAGE_NAME like '%{search_text}%' OR REDSTORE_RPMS.HUMANNAME like '%{search_text}%')) OR " \
                if i < len(groups)-1 else \
            f"(REDSTORE_GROUPS.ID = REDSTORE_RPMS.APPGROUP_ID and REDSTORE_GROUPS.GROUP_NAME='{groups[i]}' AND " \
            f"(REDSTORE_RPMS.PACKAGE_NAME like '%{search_text}%' OR REDSTORE_RPMS.HUMANNAME like '%{search_text}%'))"
    query = f"select count(*) from REDSTORE_RPMS, REDSTORE_GROUPS where {where}"
    cur.execute(query)
    result = cur.fetchall()[0][0]
    if result > 25:
        skip = 25 * current_page
        query = f"select FIRST 25 SKIP {skip} " \
                f"REDSTORE_RPMS.PACKAGE_NAME, REDSTORE_RPMS.S_DESC_ENG, REDSTORE_RPMS.S_DESC_RU, REDSTORE_RPMS.F_DESC_ENG, REDSTORE_RPMS.F_DESC_RU, \
    REDSTORE_GROUPS.GROUP_NAME, REDSTORE_RPMS.ICON, REDSTORE_RPMS.ROWSTRIDE_ICON, REDSTORE_RPMS.HEIGHT_ICON, REDSTORE_RPMS.WIDTH_ICON, REDSTORE_RPMS.ALPHA_IC, REDSTORE_RPMS.BITS_IC, \
    REDSTORE_RPMS.PICTURE1, REDSTORE_RPMS.ROWSTRIDE_PIC1, REDSTORE_RPMS.HEIGHT_PIC1, REDSTORE_RPMS.WIDTH_PIC1, REDSTORE_RPMS.ALPHA_PIC1, REDSTORE_RPMS.BITS_PIC1, \
    REDSTORE_RPMS.PICTURE2, REDSTORE_RPMS.ROWSTRIDE_PIC2, REDSTORE_RPMS.HEIGHT_PIC2, REDSTORE_RPMS.WIDTH_PIC2, REDSTORE_RPMS.ALPHA_PIC2, REDSTORE_RPMS.BITS_PIC2, \
    REDSTORE_RPMS.PICTURE3, REDSTORE_RPMS.ROWSTRIDE_PIC3, REDSTORE_RPMS.HEIGHT_PIC3, REDSTORE_RPMS.WIDTH_PIC3, REDSTORE_RPMS.ALPHA_PIC3, REDSTORE_RPMS.BITS_PIC3, \
    REDSTORE_GROUPS.GROUP_HUMAN_NAME, REDSTORE_GROUPS.GROUP_HUMAN_NAME_ENG,  REDSTORE_RPMS.HUMANNAME" \
                f"from REDSTORE_RPMS, REDSTORE_GROUPS where {where} ORDER BY lower(REDSTORE_RPMS.PACKAGE_NAME)"
    else:
        query = f"select REDSTORE_RPMS.PACKAGE_NAME, REDSTORE_RPMS.S_DESC_ENG, REDSTORE_RPMS.S_DESC_RU, REDSTORE_RPMS.F_DESC_ENG, REDSTORE_RPMS.F_DESC_RU, \
    REDSTORE_GROUPS.GROUP_NAME, REDSTORE_RPMS.ICON, REDSTORE_RPMS.ROWSTRIDE_ICON, REDSTORE_RPMS.HEIGHT_ICON, REDSTORE_RPMS.WIDTH_ICON, REDSTORE_RPMS.ALPHA_IC, REDSTORE_RPMS.BITS_IC, \
    REDSTORE_RPMS.PICTURE1, REDSTORE_RPMS.ROWSTRIDE_PIC1, REDSTORE_RPMS.HEIGHT_PIC1, REDSTORE_RPMS.WIDTH_PIC1, REDSTORE_RPMS.ALPHA_PIC1, REDSTORE_RPMS.BITS_PIC1, \
    REDSTORE_RPMS.PICTURE2, REDSTORE_RPMS.ROWSTRIDE_PIC2, REDSTORE_RPMS.HEIGHT_PIC2, REDSTORE_RPMS.WIDTH_PIC2, REDSTORE_RPMS.ALPHA_PIC2, REDSTORE_RPMS.BITS_PIC2, \
    REDSTORE_RPMS.PICTURE3, REDSTORE_RPMS.ROWSTRIDE_PIC3, REDSTORE_RPMS.HEIGHT_PIC3, REDSTORE_RPMS.WIDTH_PIC3, REDSTORE_RPMS.ALPHA_PIC3, REDSTORE_RPMS.BITS_PIC3, \
    REDSTORE_GROUPS.GROUP_HUMAN_NAME, REDSTORE_GROUPS.GROUP_HUMAN_NAME_ENG, REDSTORE_RPMS.HUMANNAME " \
                f"from REDSTORE_RPMS, REDSTORE_GROUPS " \
                f"where {where} ORDER BY lower(REDSTORE_RPMS.PACKAGE_NAME)"
    cur.execute(query)
    packs = list(cur.fetchall())
    for i in range(0, len(packs)):
        packs[i] = list(packs[i])
        for j in range(0, len(packs[i])):
            if type(packs[i][j]) == fdb.fbcore.BlobReader:
                blob = packs[i][j].read(-1)
                packs[i][j].close()
                packs[i][j] = blob
        packs[i] = {k: v for k, v in zip(keys, packs[i])}
    con.close()
    max_pages = math.ceil(result / 25)
    return [packs, result, max_pages]

#ported to new DB
def get_packages_from_query(packages):
    # con = fdb.connect(dsn='/opt/redos_education/rdb/db/rpm-lists.fdb', user='sysdba', password='masterkey')
    con = fdb.connect(dsn='/opt/redos_education/rdb/db/rpm-lists.fdb', user='sysdba', password='masterkey')
    # con = fdb.connect(dsn='/opt/redstore_web/rpm-lists.fdb', user='sysdba', password='masterkey')

    cur = con.cursor()

    keys = (
        "PACKAGE_NAME", "S_DESC_ENG", "S_DESC_RU", "F_DESC_ENG", "F_DESC_RU",
        "GROUP", "ICON", "ROWSTRIDE_ICON", "HEIGHT_ICON", "WIDTH_ICON", "ALPHA_IC", "BITS_IC",
        "PICTURE1", "ROWSTRIDE_PIC1", "HEIGHT_PIC1", "WIDTH_PIC1", "ALPHA_PIC1", "BITS_PIC1",
        "PICTURE2", "ROWSTRIDE_PIC2", "HEIGHT_PIC2", "WIDTH_PIC2", "ALPHA_PIC2", "BITS_PIC2",
        "PICTURE3", "ROWSTRIDE_PIC3", "HEIGHT_PIC3", "WIDTH_PIC3", "ALPHA_PIC3", "BITS_PIC3",
        "GROUP_NAME", "GROUP_NAME_ENG", "APP_HUMANNAME")
    where = "REDSTORE_GROUPS.ID = REDSTORE_RPMS.APPGROUP_ID and ("
    for i in range(0, len(packages)):
        where += f"REDSTORE_RPMS.PACKAGE_NAME='{packages[i]}' OR " if i < len(packages) - 1 else \
            f"REDSTORE_RPMS.PACKAGE_NAME='{packages[i]}')"

    query = f"select REDSTORE_RPMS.PACKAGE_NAME, REDSTORE_RPMS.S_DESC_ENG, REDSTORE_RPMS.S_DESC_RU, REDSTORE_RPMS.F_DESC_ENG, REDSTORE_RPMS.F_DESC_RU, \
    REDSTORE_GROUPS.GROUP_NAME, REDSTORE_RPMS.ICON, REDSTORE_RPMS.ROWSTRIDE_ICON, REDSTORE_RPMS.HEIGHT_ICON, REDSTORE_RPMS.WIDTH_ICON, REDSTORE_RPMS.ALPHA_IC, REDSTORE_RPMS.BITS_IC, \
    REDSTORE_RPMS.PICTURE1, REDSTORE_RPMS.ROWSTRIDE_PIC1, REDSTORE_RPMS.HEIGHT_PIC1, REDSTORE_RPMS.WIDTH_PIC1, REDSTORE_RPMS.ALPHA_PIC1, REDSTORE_RPMS.BITS_PIC1, \
    REDSTORE_RPMS.PICTURE2, REDSTORE_RPMS.ROWSTRIDE_PIC2, REDSTORE_RPMS.HEIGHT_PIC2, REDSTORE_RPMS.WIDTH_PIC2, REDSTORE_RPMS.ALPHA_PIC2, REDSTORE_RPMS.BITS_PIC2, \
    REDSTORE_RPMS.PICTURE3, REDSTORE_RPMS.ROWSTRIDE_PIC3, REDSTORE_RPMS.HEIGHT_PIC3, REDSTORE_RPMS.WIDTH_PIC3, REDSTORE_RPMS.ALPHA_PIC3, REDSTORE_RPMS.BITS_PIC3, \
    REDSTORE_GROUPS.GROUP_HUMAN_NAME, REDSTORE_GROUPS.GROUP_HUMAN_NAME_ENG, REDSTORE_RPMS.HUMANNAME  " \
            f"from REDSTORE_RPMS, REDSTORE_GROUPS " \
            f"where {where} ORDER BY lower(REDSTORE_RPMS.PACKAGE_NAME)"
    cur.execute(query)
    packs = list(cur.fetchall())
    for i in range(0, len(packs)):
        packs[i] = list(packs[i])
        for j in range(0, len(packs[i])):
            if type(packs[i][j]) == fdb.fbcore.BlobReader:
                blob = packs[i][j].read(-1)
                packs[i][j].close()
                packs[i][j] = blob
        packs[i] = {k: v for k, v in zip(keys, packs[i])}
    con.close()
    # max_pages = math.ceil(result / 25)
    return packs
    # [packs, result, max_pages]

#ported to new DB
def get_first_packages(group):
    # con = fdb.connect(dsn='/usr/share/redos_education/db/rpm-lists.fdb', user='sysdba', password='masterkey')
    con = fdb.connect(dsn='/opt/redos_education/rdb/db/rpm-lists.fdb', user='sysdba', password='masterkey')
    # con = fdb.connect(dsn='/opt/redstore_web/rpm-lists.fdb', user='sysdba', password='masterkey')
    cur = con.cursor()
    query = f"select count(*) from REDSTORE_RPMS, REDSTORE_GROUPS where REDSTORE_GROUPS.GROUP_NAME = '{group}' and REDSTORE_GROUPS.ID = REDSTORE_RPMS.APPGROUP_ID"
    cur.execute(query)
    packs = list(cur.fetchall())
    counter = int(packs[0][0])
    is_small = True if counter < 5 else False

    if not is_small:
        query = f"select first 5 REDSTORE_RPMS.PACKAGE_NAME, REDSTORE_RPMS.S_DESC_ENG, REDSTORE_RPMS.S_DESC_RU, REDSTORE_RPMS.F_DESC_ENG, REDSTORE_RPMS.F_DESC_RU, \
        REDSTORE_GROUPS.GROUP_NAME, REDSTORE_RPMS.ICON, REDSTORE_RPMS.ROWSTRIDE_ICON, REDSTORE_RPMS.HEIGHT_ICON, REDSTORE_RPMS.WIDTH_ICON, REDSTORE_RPMS.ALPHA_IC, REDSTORE_RPMS.BITS_IC, \
        REDSTORE_RPMS.PICTURE1, REDSTORE_RPMS.ROWSTRIDE_PIC1, REDSTORE_RPMS.HEIGHT_PIC1, REDSTORE_RPMS.WIDTH_PIC1, REDSTORE_RPMS.ALPHA_PIC1, REDSTORE_RPMS.BITS_PIC1, \
        REDSTORE_RPMS.PICTURE2, REDSTORE_RPMS.ROWSTRIDE_PIC2, REDSTORE_RPMS.HEIGHT_PIC2, REDSTORE_RPMS.WIDTH_PIC2, REDSTORE_RPMS.ALPHA_PIC2, REDSTORE_RPMS.BITS_PIC2, \
        REDSTORE_RPMS.PICTURE3, REDSTORE_RPMS.ROWSTRIDE_PIC3, REDSTORE_RPMS.HEIGHT_PIC3, REDSTORE_RPMS.WIDTH_PIC3, REDSTORE_RPMS.ALPHA_PIC3, REDSTORE_RPMS.BITS_PIC3, \
        REDSTORE_GROUPS.GROUP_HUMAN_NAME, REDSTORE_GROUPS.GROUP_HUMAN_NAME_ENG, REDSTORE_RPMS.HUMANNAME \
        from REDSTORE_RPMS, REDSTORE_GROUPS where REDSTORE_GROUPS.GROUP_NAME = '{group}' and REDSTORE_GROUPS.ID = REDSTORE_RPMS.APPGROUP_ID ORDER BY lower(REDSTORE_RPMS.PACKAGE_NAME);"
    else:
        query = f"select first {counter} REDSTORE_RPMS.PACKAGE_NAME,  REDSTORE_RPMS.S_DESC_ENG, REDSTORE_RPMS.S_DESC_RU, REDSTORE_RPMS.F_DESC_ENG, REDSTORE_RPMS.F_DESC_RU, \
                REDSTORE_GROUPS.GROUP_NAME, REDSTORE_RPMS.ICON, REDSTORE_RPMS.ROWSTRIDE_ICON, REDSTORE_RPMS.HEIGHT_ICON, REDSTORE_RPMS.WIDTH_ICON, REDSTORE_RPMS.ALPHA_IC, REDSTORE_RPMS.BITS_IC, \
                REDSTORE_RPMS.PICTURE1, REDSTORE_RPMS.ROWSTRIDE_PIC1, REDSTORE_RPMS.HEIGHT_PIC1, REDSTORE_RPMS.WIDTH_PIC1, REDSTORE_RPMS.ALPHA_PIC1, REDSTORE_RPMS.BITS_PIC1, \
                REDSTORE_RPMS.PICTURE2, REDSTORE_RPMS.ROWSTRIDE_PIC2, REDSTORE_RPMS.HEIGHT_PIC2, REDSTORE_RPMS.WIDTH_PIC2, REDSTORE_RPMS.ALPHA_PIC2, REDSTORE_RPMS.BITS_PIC2, \
                REDSTORE_RPMS.PICTURE3, REDSTORE_RPMS.ROWSTRIDE_PIC3, REDSTORE_RPMS.HEIGHT_PIC3, REDSTORE_RPMS.WIDTH_PIC3, REDSTORE_RPMS.ALPHA_PIC3, REDSTORE_RPMS.BITS_PIC3, \
                REDSTORE_GROUPS.GROUP_HUMAN_NAME, REDSTORE_GROUPS.GROUP_HUMAN_NAME_ENG, REDSTORE_RPMS.HUMANNAME \
                from REDSTORE_RPMS, REDSTORE_GROUPS where REDSTORE_GROUPS.GROUP_NAME = '{group}' and REDSTORE_GROUPS.ID = REDSTORE_RPMS.APPGROUP_ID ORDER BY lower(REDSTORE_RPMS.PACKAGE_NAME);"
    keys = (
        "PACKAGE_NAME", "S_DESC_ENG", "S_DESC_RU", "F_DESC_ENG", "F_DESC_RU",
        "GROUP", "ICON", "ROWSTRIDE_ICON", "HEIGHT_ICON", "WIDTH_ICON", "ALPHA_IC", "BITS_IC",
        "PICTURE1", "ROWSTRIDE_PIC1", "HEIGHT_PIC1", "WIDTH_PIC1", "ALPHA_PIC1", "BITS_PIC1",
        "PICTURE2", "ROWSTRIDE_PIC2", "HEIGHT_PIC2", "WIDTH_PIC2", "ALPHA_PIC2", "BITS_PIC2",
        "PICTURE3", "ROWSTRIDE_PIC3", "HEIGHT_PIC3", "WIDTH_PIC3", "ALPHA_PIC3", "BITS_PIC3",
        "GROUP_NAME", "GROUP_NAME_ENG", "APP_HUMANNAME")
    cur.execute(query)
    packs = list(cur.fetchall())
    for i in range(0, len(packs)):
        packs[i] = list(packs[i])
        for j in range(0, len(packs[i])):
            if type(packs[i][j]) == fdb.fbcore.BlobReader:
                blob = packs[i][j].read(-1)
                packs[i][j].close()
                packs[i][j] = blob
        packs[i] = {k: v for k, v in zip(keys, packs[i])}
    con.close()
    return [packs, counter]

#ported to new DB
def get_package_info(PACKAGE_NAME):
    # con = fdb.connect(dsn='/usr/share/redos_education/db/rpm-lists.fdb', user='sysdba', password='masterkey')
    con = fdb.connect(dsn='/opt/redos_education/rdb/db/rpm-lists.fdb', user='sysdba', password='masterkey')
    # con = fdb.connect(dsn='/opt/redstore_web/rpm-lists.fdb', user='sysdba', password='masterkey')

    cur = con.cursor()
    query = f"select REDSTORE_RPMS.S_DESC_ENG, REDSTORE_RPMS.S_DESC_RU, REDSTORE_RPMS.F_DESC_ENG, REDSTORE_RPMS.F_DESC_RU, " \
            f"REDSTORE_GROUPS.GROUP_NAME,\
              REDSTORE_RPMS.PICTURE1, REDSTORE_RPMS.ROWSTRIDE_PIC1, REDSTORE_RPMS.HEIGHT_PIC1, REDSTORE_RPMS.WIDTH_PIC1, REDSTORE_RPMS.ALPHA_PIC1, REDSTORE_RPMS.BITS_PIC1,\
              REDSTORE_RPMS.PICTURE2, REDSTORE_RPMS.ROWSTRIDE_PIC2, REDSTORE_RPMS.HEIGHT_PIC2, REDSTORE_RPMS.WIDTH_PIC2, REDSTORE_RPMS.ALPHA_PIC2, REDSTORE_RPMS.BITS_PIC2,\
              REDSTORE_RPMS.PICTURE3, REDSTORE_RPMS.ROWSTRIDE_PIC3, REDSTORE_RPMS.HEIGHT_PIC3, REDSTORE_RPMS.WIDTH_PIC3, REDSTORE_RPMS.ALPHA_PIC3, REDSTORE_RPMS.BITS_PIC3, " \
            f"REDSTORE_RPMS.HUMANNAME \
              from REDSTORE_RPMS, REDSTORE_GROUPS" \
            f" where REDSTORE_RPMS.PACKAGE_NAME='{PACKAGE_NAME}' and REDSTORE_GROUPS.ID = REDSTORE_RPMS.APPGROUP_ID"

    keys = ("S_DESC_ENG", "S_DESC_RU", "F_DESC_ENG", "F_DESC_RU",
            "GROUP",
            "PICTURE1", "ROWSTRIDE_PIC1", "HEIGHT_PIC1", "WIDTH_PIC1", "ALPHA_PIC1", "BITS_PIC1",
            "PICTURE2", "ROWSTRIDE_PIC2", "HEIGHT_PIC2", "WIDTH_PIC2", "ALPHA_PIC2", "BITS_PIC2",
            "PICTURE3", "ROWSTRIDE_PIC3", "HEIGHT_PIC3", "WIDTH_PIC3", "ALPHA_PIC3", "BITS_PIC3",
            "APP_HUMANNAME"
            )
    cur.execute(query)
    packs = list(cur.fetchall())
    for i in range(0, len(packs)):
        packs[i] = list(packs[i])
        for j in range(0, len(packs[i])):
            if type(packs[i][j]) == fdb.fbcore.BlobReader:
                blob = packs[i][j].read(-1)
                packs[i][j].close()
                packs[i][j] = blob
        packs[i] = {k: v for k, v in zip(keys, packs[i])}
    con.close()
    return packs[0]

def get_groups_names():
    con = fdb.connect(dsn='/opt/redos_education/rdb/db/rpm-lists.fdb', user='sysdba', password='masterkey')
    # con = fdb.connect(dsn='/opt/redstore_web/rpm-lists.fdb', user='sysdba', password='masterkey')
    cur = con.cursor()
    query = "select REDSTORE_PARENTGROUPS.GROUP_PARENT, REDSTORE_GROUPS.GROUP_NAME " \
            "from REDSTORE_GROUPS, REDSTORE_PARENTGROUPS " \
            "where REDSTORE_GROUPS.GROUP_PARENT_ID_ID = REDSTORE_PARENTGROUPS.ID;"

    cur.execute(query)
    pairs = list(cur.fetchall())

    query = "select GROUP_PARENT from REDSTORE_PARENTGROUPS;"
    cur.execute(query)
    parents = list(cur.fetchall())

    out_parents = []
    for p in parents:
        out_parents.append(p[0])

    groups_structure = {}
    groups_page = {}
    groups = {}
    query = "select DISTINCT REDSTORE_PARENTGROUPS.GROUP_PARENT, REDSTORE_GROUPS.GROUP_NAME " \
            "from REDSTORE_GROUPS, REDSTORE_PARENTGROUPS;"
    cur.execute(query)
    grps = list(cur.fetchall())

    query = "select DISTINCT REDSTORE_PARENTGROUPS.GROUP_PARENT," \
            " REDSTORE_PARENTGROUPS.GROUP_PARENT_HUMAN_NAME, REDSTORE_PARENTGROUPS.GROUP_PARENT_HUMAN_NAME_ENG, " \
            "REDSTORE_GROUPS.GROUP_NAME, " \
            "REDSTORE_GROUPS.GROUP_HUMAN_NAME, REDSTORE_GROUPS.GROUP_HUMAN_NAME_ENG " \
            "from REDSTORE_GROUPS, REDSTORE_PARENTGROUPS where REDSTORE_PARENTGROUPS.ID = REDSTORE_GROUPS.GROUP_PARENT_ID_ID;"
    cur.execute(query)
    grps_trans = list(cur.fetchall())
    groups_page_translations = {}

    for i in range(0, len(grps_trans)):
        groups_page_translations[grps_trans[i][0]] = grps_trans[i][1] if "ru_RU" in os.getenv('LANG') else grps_trans[i][2]
        groups_page_translations[grps_trans[i][3]] = grps_trans[i][4] if "ru_RU" in os.getenv('LANG') else grps_trans[i][5]

    con.close()

    for i in range(0, len(parents)):
        groups_structure[parents[i][0]] = []

    for i in range(0, len(grps)):
        groups_page[grps[i][0]] = 0
        groups[grps[i][0]] = []
        groups[grps[i][1]] = []

    for i in range(0, len(pairs)):
        groups_structure[pairs[i][0]].append(pairs[i][1])
    return [groups_structure, groups_page, groups, out_parents, groups_page_translations]
