import gettext

import gi
import platform
import locale
import random
gi.require_version('GdkPixbuf', '2.0')
gi.require_version("Gtk", "3.0")

from gi.repository import Gtk, Gio, Gdk, GdkPixbuf, GLib
gettext.bindtextdomain('redos_education', '/opt/redos_education/ui/locale')
# gettext.bindtextdomain('redos_education', 'ui/locale')

gettext.textdomain('redos_education')
_ = gettext.gettext

locale.bindtextdomain("redos_education", "/opt/redos_education/ui/locale")
# locale.bindtextdomain("redos_education", "ui/locale")

locale.textdomain("redos_education")

builder = Gtk.Builder()
builder.set_translation_domain("redos_education")
LAYOUT_STYLE_LEGACY, LAYOUT_STYLE_NEW = range(2)

builder.add_from_file('/opt/redos_education/ui/redos_education.glade')
# builder.add_from_file('./ui/redos_education.glade')

class LoadScreen:
    def __init__(self):
        self.window = builder.get_object("load_window")
        self.progressbar = builder.get_object("progressbar")
        self.timeout_id = GLib.timeout_add(60, self.on_timeout, None)

    def on_timeout(self, user_data):
        self.progressbar.pulse()
        return True

if __name__ == "__main__":
    screen = Gdk.Screen.get_default()
    provider = Gtk.CssProvider()
    provider.load_from_path("/opt/redos_education/ui/style.css")
    Gtk.StyleContext.add_provider_for_screen(screen, provider, Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION)
    win = LoadScreen()
    win.window.set_icon_from_file("/opt/redos_education/ui/redos-education.svg")
    win.window.set_title(_("Loading"))

    win.window.show_all()
    Gtk.main()