#!/usr/bin/python3
import configparser

from dnf.cli.commands.repoquery import PackageWrapper
from pydbus import SystemBus
import os, sys, gi
gi.require_version('GdkPixbuf', '2.0')
gi.require_version("Gtk", "3.0")

from gi.repository import Gtk, Gio, Gdk, GdkPixbuf, GLib, GObject
bus = SystemBus()
the_dbus_starter = bus.get("org.redos.edu.pydbus.Starter")
whoami = GLib.get_user_name()
#if os.path.exists("/tmp/firebird"):
the_dbus_starter.set_acl_firebird(whoami)
# the_dbus_starter.clean_tmp_firebird()

import gettext
import time

import gi
import platform
import locale
import random


import get_group_packages
import threading

import dnf
from dnf.conf import Conf
from dnf.cli.cli import Cli
from dnf.cli.option_parser import OptionParser
from dnf.i18n import ucd
import dnf.cli.option_parser
import dnf.i18n
from dnf.cli import commands

import hawkey, os, sys, re

import commands_opts

DEVEL_FLAG = False

builder = Gtk.Builder()
builder.set_translation_domain("redos_education")
LAYOUT_STYLE_LEGACY, LAYOUT_STYLE_NEW = range(2)

gettext.textdomain('redos_education')
_ = gettext.gettext


locale.textdomain("redos_education")


installed_list = []
updates_list = []
query_updates_all = []


groups_structure, groups_page, groups, parents, groups_page_translations = get_group_packages.get_groups_names()
groups_len = groups.copy()
groups_page_translations["Installed"] = _("Installed")
groups_page_translations["Updates"] = _("Updates")


opts_install = commands_opts.opts_install
opts_changelogs = commands_opts.opts_changelogs
opts_remove = commands_opts.opts_remove
opts_update = commands_opts.opts_update
use_refresh = False

def build_format_fn(opts, pkg):
    if opts.querychangelogs:
        out = []
        # out.append('Changelog for %s' % str(pkg))
        for chlog in pkg.changelogs:
            dt = chlog['timestamp']
            out.append('* %s %s\n%s\n' % (dt.strftime("%a %b %d %Y"),
                                          dnf.i18n.ucd(chlog['author']),
                                          dnf.i18n.ucd(chlog['text'])))
        return '\n'.join(out)

def versiontuple(v):
    return tuple(map(int, (v.split("."))))

def unload_dnf():
    # функция обходной путь, тк dnf не умеет в многократный импорт себя
    # и начинает спамить в логах рекурсивно увеличивающимся выводом информации
    global base_dnf
    massive = []
    for module in sys.modules:
        if 'dnf' in str(module):
            massive.append(str(module))
    for module in massive:
        del sys.modules[module]
    import dnf
    from dnf.conf import Conf
    from dnf.cli.cli import Cli
    from dnf.cli.option_parser import OptionParser
    from dnf.i18n import ucd
    import dnf.cli.option_parser
    import dnf.i18n
    from dnf.cli import commands

def get_artibute(path, section, setting):  # добавление или изменние параметров в конфигах
    config = configparser.ConfigParser(delimiters='=')
    config.read(path)
    section_ = config[section]
    value = ""
    try:
        value = section_.get(setting)
        return value
    except Exception as e:
        return value

def get_artibute_from_desktop(path, section, setting):  # добавление или изменние параметров в конфигах
    with open(path, 'r') as desktop:
        data = desktop.read()
    data = re.sub(r"%[a-zA-Z]", "", data)
    config = configparser.ConfigParser(delimiters='=')
    config.read_string(data)
    section_ = config[section]
    value = ""
    try:
        value = section_.get(setting)
        return value
    except Exception as e:
        return value

def get_atr_from_all_sections(path, setting):
    config = configparser.ConfigParser(delimiters='=')
    config.read(path)
    vals = ""
    for section in config.sections():
        section_ = config[section]
        try:
            try:
                if section_.get("enabled") == 1:
                    out = section_.get(setting)
                    if out:
                        vals += out
            except:
                out = section_.get(setting)
                if out:
                    vals += out

        except Exception as e:
            pass
    return vals

def get_sections(path):
    config = configparser.ConfigParser(delimiters='=')
    config.read(path)
    return config.sections()

def recreate_dnf_base_query():
    global base_dnf
    base_dnf = dnf.Base()

    vals = get_artibute(path="/etc/dnf/dnf.conf", section="main", setting="exclude")

    for filename in os.listdir("/etc/yum.repos.d/"):
        if filename.endswith(".repo"):
            out = get_atr_from_all_sections(f"/etc/yum.repos.d/{str(filename)}", "exclude")
            if out:
                vals += " " + out
    for filename in os.listdir("/etc/distro.repos.d/"):
        if filename.endswith(".repo"):
            out = get_atr_from_all_sections(f"/etc/distro.repos.d/{str(filename)}", "exclude")
            if out:
                vals += " " + out            
    if vals != None:
        vals = vals.strip()
        excludes = vals.split(" ")
    else:
        excludes = []
    if excludes:
        opts_changelogs.excludepkgs=excludes
    base_dnf.conf._configure_from_options(opts_changelogs)
    base_dnf.conf._adjust_conf_options()
    repos = base_dnf.repos
    base_dnf.read_all_repos(opts=opts_changelogs)

    if opts_changelogs.repo:
        opts_changelogs.repos_ed.insert(0, ("*", "disable"))
        opts_changelogs.repos_ed.extend([(r, "enable") for r in opts_changelogs.repo])
    global use_refresh    
    for repo in repos.iter_enabled():
        repo.load_metadata_other = True
        if use_refresh:
            repo._repo.expire()
            repo._repo.setSyncStrategy(dnf.repo.SYNC_LAZY)
        else:
            repo._repo.setSyncStrategy(dnf.repo.SYNC_TRY_CACHE)
        base_dnf._conf.skip_if_unavailable = True
    base_dnf.fill_sack()


os.system("/usr/bin/python3 /opt/redos_education/load_screen.py &")
# os.system("/usr/bin/python3 /home/wolandius/git_projects/redos_education/load_screen.py &")

def create_query(type, key=None):
    global base_dnf
    q = base_dnf.sack.query(hawkey.APPLY_EXCLUDES)
    q = base_dnf._merge_update_filters(q, warning=False)
    if key:
        query_results = q.filter(empty=True)
        opts_changelogs.key = [key]
    else:
        opts_changelogs.key = []
    for key in opts_changelogs.key:
        query_results = query_results.union(
            dnf.subject.Subject(key, ignore_case=True).get_best_query(
                base_dnf.sack, with_provides=False, query=q))
    if key:
        q = query_results
    if not opts_changelogs.list:
        # do not show packages from @System repo
        avail_q = q.available()
    if type == "available":
        q = base_dnf._merge_update_filters(avail_q, warning=False)
    elif type == "installed":
        q = base_dnf._merge_update_filters(q.installed(), warning=False)
    elif type == "updates":
        q = base_dnf._merge_update_filters(q.upgrades(), warning=False)
    return q


def fill_groups():
    global groups, groups_structure, groups_len
    for group in groups_structure:
        groups_len[group] = 0
        for key in groups_structure[group]:
            output = get_group_packages.get_first_packages(group=key)
            groups[group] = groups[group] + output[0]
            groups_len[group] = groups_len[group] + output[1]

def create_installed_list():
    global installed_list
    installed_list = []
    query_installed = create_query("installed").run()
    chunks = [query_installed[x:x + 500] for x in range(0, len(query_installed), 500)]

    for chunk in chunks:
        def func_chunk(*inputs):
            inputs = list(inputs)
            for i in range(0, len(inputs)):
                inputs[i] = inputs[i].name
            packs = get_group_packages.get_packages_from_query(inputs)
            if len(packs) > 0:
                for el in packs:
                    installed_list.append(el)
            return "success"

        def pass_callback(worker, result, handler_data):
            result = worker.return_value(result)

        inputs = chunk
        async_worker = AsyncWorker(
            operation=func_chunk,
            operation_inputs=inputs,
            operation_callback=pass_callback
        )
        async_worker.start()

def create_updates_list():
    global updates_list, query_updates_all
    updates_list = []
    query_updates = create_query("updates").run()

    query_updates_all = query_updates
    chunks = [query_updates[x:x + 500] for x in range(0, len(query_updates), 500)]

    for chunk in chunks:
        def func_chunk(*inputs):
            inputs = list(inputs)
            for i in range(0, len(inputs)):
                inputs[i] = inputs[i].name
            packs = get_group_packages.get_packages_from_query(inputs)
            if len(packs) > 0:
                for el in packs:
                    updates_list.append(el)
            return "success"

        def pass_callback(worker, result, handler_data):
            result = worker.return_value(result)

        inputs = chunk
        async_worker = AsyncWorker(
            operation=func_chunk,
            operation_inputs=inputs,
            operation_callback=pass_callback
        )
        async_worker.start()


def truncate_list(current_page, list_for_truncate):
    chunks = [list_for_truncate[x:x + 25] for x in range(0, len(list_for_truncate), 25)]
    if len(chunks) > 0:
        return [chunks[current_page], len(chunks)]
    else:
        return [[], 0]


class RedosStore:
    def __init__(self):
        self.window = builder.get_object("main_window")
        self.window.set_title(_("Soft for the educational process"))
        self.window.set_icon_from_file("/opt/redos_education/ui/redos-education32.png")
        self.stack = builder.get_object("MainStack")
        self.home = builder.get_object("home")
        self.back = builder.get_object("back")
        self.back.connect("clicked", self.open_home)
        self.home.connect("clicked", self.show_all_packages)
        self.three_buttons = builder.get_object("main_three_buttons")
        self.progresscache = builder.get_object("progresscache")
        self.wait_box = builder.get_object("wait_box")
        self.wait_box.hide()
        self.menu_popover =  builder.get_object("menu_popover")
        self.back.set_sensitive(False)
        self.stack.set_visible_child_name("home")
        self.app_page = None
        self.page_group = None
        self.sub_stack = None
        self.status_image = builder.get_object("status_image")
        self.Menu = builder.get_object("menu")
        self.Menu.set_label(_("Menu"))
        if DEVEL_FLAG:
            self.Menu.set_image(Gtk.Image.new_from_file("/home/wolandius/git_projects/redos_education/ui/arrow-down.svg"))
        else:
            self.Menu.set_image(Gtk.Image.new_from_file("/opt/redos_education/ui/arrow-down.svg"))

        self.Menu.set_always_show_image(True)
        global groups, parents, groups_len

        main_list_box = builder.get_object("main_list_box")
        popupmenubox = builder.get_object(f"popupmenubox")
        self.groupsmenubutton = builder.get_object(f"groupsmenubutton")
        self.groupsmenubutton.set_label(_("Groups"))
        if DEVEL_FLAG:
            self.groupsmenubutton.set_image(Gtk.Image.new_from_file("/home/wolandius/git_projects/redos_education/ui/arrow-down.svg"))
        else:
            self.groupsmenubutton.set_image(Gtk.Image.new_from_file("/opt/redos_education/ui/arrow-down.svg"))
        #

        self.groupsmenubutton.set_always_show_image(True)

        self.timeout_cache = GLib.timeout_add(80, self.on_timeout_cache, None)


        for group in parents:
            temp_builder = Gtk.Builder()
            if DEVEL_FLAG:
                temp_builder.add_from_file('/home/wolandius/git_projects/redos_education/ui/templates.glade')
            else:
                temp_builder.add_from_file('/opt/redos_education/ui/templates.glade')
            #

            grouprow = temp_builder.get_object(f"grouprow")
            grouprow.set_name(f"{group}_ROW")
            popupmenubox.add(grouprow)

            # group_human_name_menu = temp_builder.get_object(f"group_human_name_menu")
            # group_human_name_menu.set_text(f"{groups_page_translations[group]}")

            up_level_box = temp_builder.get_object(f"GROUPNAME_LISTBOX")
            group_label = temp_builder.get_object(f"group_human_name")
            group_label.set_text(f"{groups_page_translations[group]}")
            box = temp_builder.get_object(f"GROUPNAME_BOX")
            box.set_name(f"{group}_BOX")
            main_list_box.pack_start(up_level_box, True, True, 3)
            # if len(groups[group]) >= 4:
            #     list_of_random_items = random.sample(groups[group], 4)
            # elif len(groups[group]) >= 3:
            #     list_of_random_items = random.sample(groups[group], 3)
            # else:
            #     list_of_random_items = random.sample(groups[group], len(groups[group]))
            list_of_random_items = groups[group]
            for i in range(0, len(list_of_random_items)):
                template_button = self.create_button_from_packs(list_of_random_items, i, False, True)
                # box.pack_start(template_button, True, True, 0)
                box.insert(template_button, -1)
            group_button = temp_builder.get_object("more_group")
            group_button.set_label(f"{group_button.get_label()} ({groups_len[group]})")
            more_group_menu = temp_builder.get_object("more_group_menu")
            more_group_menu.set_label(groups_page_translations[group])
            if len(groups_structure[group]) > 1:
                group_button.connect(
                    "clicked",
                    self.open_page,
                    group, True,
                    group, groups_structure[group],
                    0, "zero", False)
                more_group_menu.connect(
                    "clicked",
                    self.open_page,
                    group, True,
                    group, groups_structure[group],
                    0, "zero", False, True)
            else:
                group_button.connect(
                    "clicked", self.open_page,
                    group, True,
                    group,[],
                    0, "zero", True)
                more_group_menu.connect(
                    "clicked", self.open_page,
                    group, True,
                    group, [],
                    0, "zero", True, True)

        self.search_box = builder.get_object("SEARCH_BOX")
        self.search_entry = builder.get_object("search_entry")
        self.search_button = builder.get_object("search_button")
        text = self.search_entry.get_text()

        self.search_button.connect("clicked", self.search_packages, "zero", text)

        self.all_button = builder.get_object("view_all_packs")
        self.installed_button = builder.get_object("view_installed_packs")
        self.updates_button = builder.get_object("view_update_packs")
        self.update_all_button = builder.get_object("update_all_button")
        self.update_stack = builder.get_object("update_stack")
        self.progress_update_bar = builder.get_object("progress_update_bar")
        self.upd_error_details_button = builder.get_object("upd_error_details_button")
        self.timeout_upd_all = GLib.timeout_add(80, self.on_timeout_upd_all, None)

        self.all_button.connect("clicked", self.show_all_packages)
        self.installed_button.connect("clicked", self.show_installed_packages, "zero")
        self.updates_button.connect("clicked", self.show_updates_packages, "zero")
        self.update_all_button.connect("clicked", self.on_all_update_button_clicked)

        self.buttons_for_block = [self.Menu, self.search_button, self.back, self.all_button,
                                  self.installed_button, self.updates_button, self.home, self.groupsmenubutton]

        self.wait_label = builder.get_object("wait_label")
        self.groups_popover = builder.get_object("groups_popover")

        builder.get_object("refresh_metadata").connect("clicked", self.refresh_metadata)
        builder.get_object("manage_repolist").hide()
        builder.get_object("menu_all").connect("clicked", self.show_all_packages)
        builder.get_object("menu_installed_packs").connect("clicked", self.show_installed_packages, "zero")
        builder.get_object("menu_update_packs").connect("clicked", self.show_updates_packages, "zero")
        builder.get_object("exit").connect("clicked", self.close)
        #
        self.window.set_position(Gtk.WindowPosition.CENTER)
        self.window.connect("destroy", Gtk.main_quit)
        self.blocked_button = None
        self.search_stack = builder.get_object("search_stack")
        self.installed_stack = builder.get_object("installed_stack")
        self.updates_stack = builder.get_object("updates_stack")
        self.window.show()

    def on_timeout_cache(self, user_data):
        self.progresscache.pulse()
        return True

    def on_timeout_upd_all(self, user_data):
        self.progress_update_bar.pulse()
        return True

    def close(self, button):
        self.window.emit('delete-event', Gdk.Event(Gdk.EventType.DELETE))

    def show_error(self, button, error):
        win = RedosStoreError()
        win.set_text(error)

    def refresh_metadata(self, button):
        # threads = []
        self.search_button.set_sensitive(False)
        self.three_buttons.hide()
        self.groupsmenubutton.hide()
        self.Menu.set_sensitive(False)
        self.stack.set_sensitive(False)
        self.all_button.set_sensitive(False)
        self.installed_button.set_sensitive(False)
        self.updates_button.set_sensitive(False)
        # self.wait_label.show()
        self.wait_box.show()
        # self.progresscache.show()
        # self.progresscache.pulse()
            
        def func_refresh_metadata(*inputs):
            global use_refresh
            unload_dnf()
            use_refresh = True
            recreate_dnf_base_query()
            use_refresh = False
            create_updates_list()
            create_installed_list()
            return "success"

        def pass_callback(worker, result, handler_data):
            result = worker.return_value(result)
            if result == "success":
                # self.wait_label.hide()
                self.wait_box.hide()
                self.search_button.set_sensitive(True)
                self.Menu.set_sensitive(True)
                self.stack.set_sensitive(True)
                self.all_button.set_sensitive(True)
                self.installed_button.set_sensitive(True)
                self.updates_button.set_sensitive(True)
                self.three_buttons.show()
                self.groupsmenubutton.show()

        inputs = ()
        async_worker = AsyncWorker(
            operation=func_refresh_metadata,
            operation_inputs=inputs,
            operation_callback=pass_callback
        )
        async_worker.start()

    # SIU mean search, installed, updates
    def remove_SIU_stacks(self):
        if self.search_stack.get_visible_child_name() == "search_results_page":
            for child in self.search_stack.get_child_by_name("search_results_page"):
                self.search_stack.get_child_by_name("search_results_page").remove(child)
            self.search_stack.remove(self.search_stack.get_child_by_name("search_results_page"))
        if self.installed_stack.get_visible_child_name() == "installed_results_page":
            for child in self.installed_stack.get_child_by_name("installed_results_page"):
                self.installed_stack.get_child_by_name("installed_results_page").remove(child)
            self.installed_stack.remove(self.installed_stack.get_child_by_name("installed_results_page"))
        if self.updates_stack.get_visible_child_name() == "updates_results_page":
            for child in self.updates_stack.get_child_by_name("updates_results_page"):
                self.updates_stack.get_child_by_name("updates_results_page").remove(child)
            self.updates_stack.remove(self.updates_stack.get_child_by_name("updates_results_page"))

    def show_all_packages(self, button):
        if self.page_group and self.app_page and (self.stack.get_visible_child_name() == "search" or
                                                  self.stack.get_visible_child_name() == "installed" or
                                                  self.stack.get_visible_child_name() == "updates"):
            self.stack.set_visible_child_name("home")
            self.blocked_button.set_sensitive(True)
            self.blocked_button = None
            self.back.set_sensitive(False)
            self.remove_SIU_stacks()
            self.sub_stack.remove(self.app_page)
            self.stack.remove(self.page_group)
            self.page_group.destroy()
            self.app_page.destroy()
            self.search_button.set_sensitive(True)
            self.app_page = None
            self.page_group = None

        elif self.page_group and (self.stack.get_visible_child_name() == "search" or
                                  self.stack.get_visible_child_name() == "installed" or
                                  self.stack.get_visible_child_name() == "updates"):
            self.stack.set_visible_child_name("home")
            self.blocked_button.set_sensitive(True)
            self.blocked_button = None
            self.back.set_sensitive(False)
            self.remove_SIU_stacks()
            self.page_group.destroy()
            self.page_group = None
            self.sub_stack.remove(self.sub_main_page)
            self.search_button.set_sensitive(True)
        elif self.stack.get_visible_child_name() == "search" or \
                self.stack.get_visible_child_name() == "installed" or \
                self.stack.get_visible_child_name() == "updates":
            self.stack.set_visible_child_name("home")
            self.back.set_sensitive(False)
            self.remove_SIU_stacks()
            self.search_button.set_sensitive(True)
        elif self.page_group and self.app_page:
            self.stack.set_visible_child_name("home")
            # self.sub_stack.remove(self.sub_main_page)
            self.stack.remove(self.page_group)
            self.page_group.destroy()
            self.page_group = None
            self.sub_stack.remove(self.app_page)
            self.app_page.destroy()
            self.search_button.set_sensitive(True)
            self.app_page = None
            self.blocked_button.set_sensitive(True)
            self.blocked_button = None
        elif self.page_group:
            self.stack.set_visible_child_name("home")
            self.stack.remove(self.page_group)
            self.page_group.destroy()
            self.page_group = None
            self.back.set_sensitive(False)
            self.search_button.set_sensitive(True)
            self.blocked_button.set_sensitive(True)
            self.blocked_button = None
        elif self.app_page:
            self.stack.set_visible_child_name("home")
            if self.search_stack.get_visible_child_name() == "search_results_page":
                for child in self.search_stack.get_child_by_name("search_results_page"):
                    self.search_stack.get_child_by_name("search_results_page").remove(child)
                self.search_stack.remove(self.search_stack.get_child_by_name("search_results_page"))
            self.search_button.set_sensitive(True)
            self.stack.remove(self.app_page)
            self.app_page.destroy()
            self.app_page = None
            self.back.set_sensitive(False)
        # self.groupsmenubutton.show()
        self.back.hide()
        self.home.hide()
        if not self.window.is_maximized():
            self.window.resize(900, 700)

    def show_installed_packages(self, button, page_flag):
        if self.app_page:
            try:
                self.sub_stack.remove(self.app_page)
            except:
                self.stack.remove(self.app_page)
            self.app_page.destroy()
            self.app_page = None

        if self.search_stack.get_visible_child_name() == "search_results_page":
            for child in self.search_stack.get_child_by_name("search_results_page"):
                self.search_stack.get_child_by_name("search_results_page").remove(child)
            self.search_stack.remove(self.search_stack.get_child_by_name("search_results_page"))
        if self.installed_stack.get_visible_child_name() == "installed_results_page":
            for child in self.installed_stack.get_child_by_name("installed_results_page"):
                self.installed_stack.get_child_by_name("installed_results_page").remove(child)
            self.installed_stack.remove(self.installed_stack.get_child_by_name("installed_results_page"))
        if self.updates_stack.get_visible_child_name() == "updates_results_page":
            for child in self.updates_stack.get_child_by_name("updates_results_page"):
                self.updates_stack.get_child_by_name("updates_results_page").remove(child)
            self.updates_stack.remove(self.updates_stack.get_child_by_name("updates_results_page"))

        global installed_list

        if page_flag == "zero":
            groups_page["INSTALLED"] = 0
        elif page_flag == "next":
            groups_page["INSTALLED"] += 1
        elif page_flag == "previous":
            groups_page["INSTALLED"] -= 1

        builder = Gtk.Builder()
        if DEVEL_FLAG:
            builder.add_from_file('/home/wolandius/git_projects/redos_education/ui/templates.glade')
        else:
            builder.add_from_file('/opt/redos_education/ui/templates.glade')
        # builder.add_from_file('/home/wolandius/git_projects/redos_education/ui/templates.glade')


        listbox = builder.get_object("installed_results")
        listbox_results = builder.get_object("box_installed")

        packs, max_page = truncate_list(groups_page["INSTALLED"], installed_list)

        len_packs = len(packs)
        max_page -= 1 if max_page > 0 else 0

        installed_page_box1 = builder.get_object("installed_page_box1")
        installed_page_box2 = builder.get_object("installed_page_box2")

        installed_prev1 = builder.get_object("installed_prev1")
        installed_prev2 = builder.get_object("installed_prev2")
        installed_next1 = builder.get_object("installed_next1")
        installed_next2 = builder.get_object("installed_next2")

        if len_packs > 24:
            installed_page_box1.set_visible(True)
            installed_page_box2.set_visible(True)
            if groups_page["INSTALLED"] == 0:
                installed_prev1.set_sensitive(False)
                installed_prev2.set_sensitive(False)
            elif groups_page["INSTALLED"] > 0:
                installed_prev1.set_sensitive(True)
                installed_prev2.set_sensitive(True)
                installed_prev1.connect("clicked", self.show_installed_packages, "previous")
                installed_prev2.connect("clicked", self.show_installed_packages, "previous")
            if groups_page["INSTALLED"] == max_page:
                installed_next1.set_sensitive(False)
                installed_next2.set_sensitive(False)
            elif groups_page["INSTALLED"] < max_page:
                installed_next1.set_sensitive(True)
                installed_next2.set_sensitive(True)
                installed_next1.connect("clicked", self.show_installed_packages, "next")
                installed_next2.connect("clicked", self.show_installed_packages, "next")
        else:
            groups_page["INSTALLED"] = 0
            installed_page_box1.set_visible(False)
            installed_page_box2.set_visible(False)

        if len(packs) > 0:
            for i in range(0, len(packs)):
                template_button = self.create_button_from_packs(packs, i, False, True)
                listbox_results.insert(template_button, -1)
                self.stack.set_visible_child_name("installed")
                self.installed_stack.add_named(listbox, "installed_results_page")
                self.installed_stack.set_visible_child_name("installed_results_page")
                self.back.set_sensitive(True)
                self.back.show()
                self.home.show()
        else:
            groups_page["INSTALLED"] = 0
            installed_page_box1.set_visible(False)
            installed_page_box2.set_visible(False)
            self.stack.set_visible_child_name("installed")
            self.installed_stack.set_visible_child_name("installed_results_empty")
            self.back.set_sensitive(True)
            self.back.show()
            self.home.show()

    def on_all_update_button_clicked(self, button, ):
        out = os.popen("systemctl is-active redos-edu-dbus.service").readline().strip()
        if out == "inactive":
            the_dbus_starter.start()
        self.redos_dnf = bus.get("org.redos.edu.pydbus.RedosEdu", timeout=600)
        granted_access = self.redos_dnf.status_auth()
        if granted_access != "True":
            granted_access = self.redos_dnf.granteAuth(True)
        else:
            granted_access = "rules granted"
        if granted_access == "rules granted":
            self.update_stack.set_visible_child_name("progress_upd_page")
            self.progress_update_bar.set_text(_(f"Prepare to update"))
            self.progress_update_bar.pulse()
            # self.progress_update_bar.set_fraction(0.25)
            self.updates_stack.set_sensitive(False)
            for button_ in self.buttons_for_block:
                button_.set_sensitive(False)
            dependencies, errors = self.redos_dnf.dependencies_all_update().split("|||")
            if "Операция отменена" in errors or "Operation aborted" in errors or "Операция прервана" in errors:
                win = RedosStoreResolveDeps()
                dependencies = dependencies.split("\n")
                output = ""
                key = -1
                for i in range(0, len(dependencies)):
                    if "=" in dependencies[i]:
                        key = i
                        break
                if key > -1:
                    dependencies = dependencies[key + 1:]
                for i in range(0, len(dependencies)):
                    temp = dependencies[i].strip().split()

                    if len(temp) > 5:
                        dependencies[i] = f'\t{temp[0]}-{temp[2]}.{temp[1]} {temp[3]} {temp[4]}{temp[5]}'
                    elif len(temp) == 5:
                        dependencies[i] = f'\t{temp[0]}-{temp[2]}.{temp[1]} {temp[3]} {temp[4]}'
                    else:
                        dependencies[i] = f'<b> {dependencies[i]}</b>'
                    output += f"{dependencies[i]}\n"

                win.accept_button.connect("clicked", self.action_upd_all,
                                          self.update_stack, self.updates_stack, win)

                win.deny_button.connect("clicked", win.close_upd_all, self.update_stack, self.updates_stack,
                                        self.buttons_for_block, self.progress_update_bar)
                win.window.connect("delete-event", win.custom_delete_upd_all, self.update_stack, self.updates_stack,
                                        self.buttons_for_block, self.progress_update_bar)
                win.set_text(output)
            else:
                win = RedosStoreError()
                win.set_text(errors, self.update_stack, self.updates_stack,
                                        self.buttons_for_block, self.progress_update_bar)

    def show_updates_packages(self, button, page_flag):
        if self.app_page:
            try:
                self.sub_stack.remove(self.app_page)
            except:
                self.stack.remove(self.app_page)
            self.app_page.destroy()
            self.app_page = None

        if self.search_stack.get_visible_child_name() == "search_results_page":
            for child in self.search_stack.get_child_by_name("search_results_page"):
                self.search_stack.get_child_by_name("search_results_page").remove(child)
            self.search_stack.remove(self.search_stack.get_child_by_name("search_results_page"))
        if self.installed_stack.get_visible_child_name() == "installed_results_page":
            for child in self.installed_stack.get_child_by_name("installed_results_page"):
                self.installed_stack.get_child_by_name("installed_results_page").remove(child)
            self.installed_stack.remove(self.installed_stack.get_child_by_name("installed_results_page"))
        if self.updates_stack.get_visible_child_name() == "updates_results_page":
            for child in self.updates_stack.get_child_by_name("updates_results_page"):
                self.updates_stack.get_child_by_name("updates_results_page").remove(child)
            self.updates_stack.remove(self.updates_stack.get_child_by_name("updates_results_page"))
        if self.updates_stack.get_visible_child_name() == "updates_all_results_page":
            for child in self.updates_stack.get_child_by_name("updates_all_results_page"):
                self.updates_stack.get_child_by_name("updates_all_results_page").remove(child)
            self.updates_stack.remove(self.updates_stack.get_child_by_name("updates_all_results_page"))
        global updates_list, updates_all_list

        if page_flag == "zero":
            groups_page["UPDATES"] = 0
        elif page_flag == "next":
            groups_page["UPDATES"] += 1
        elif page_flag == "previous":
            groups_page["UPDATES"] -= 1
        self.status_image.hide()
        builder = Gtk.Builder()
        if DEVEL_FLAG:
            builder.add_from_file('/home/wolandius/git_projects/redos_education/ui/templates.glade')
        else:
            builder.add_from_file('/opt/redos_education/ui/templates.glade')
        #
        listbox = builder.get_object("updates_results")
        listbox_results = builder.get_object("box_updates")

        packs, max_page = truncate_list(groups_page["UPDATES"], updates_list)

        len_packs = len(packs)
        max_page -= 1 if max_page > 0 else 0
        #
        updates_page_box1 = builder.get_object("updates_page_box1")
        updates_page_box2 = builder.get_object("updates_page_box2")

        updates_prev1 = builder.get_object("updates_prev1")
        updates_prev2 = builder.get_object("updates_prev2")
        updates_next1 = builder.get_object("updates_next1")
        updates_next2 = builder.get_object("updates_next2")
        self.update_all_button.set_visible(True)
        if len_packs > 24:
            updates_page_box1.set_visible(True)
            updates_page_box2.set_visible(True)
            if groups_page["UPDATES"] == 0:
                updates_prev1.set_sensitive(False)
                updates_prev2.set_sensitive(False)
            elif groups_page["UPDATES"] > 0:
                updates_prev1.set_sensitive(True)
                updates_prev2.set_sensitive(True)
                updates_prev1.connect("clicked", self.show_updates_packages, "previous")
                updates_prev2.connect("clicked", self.show_updates_packages, "previous")
            if groups_page["UPDATES"] == max_page:
                updates_next1.set_sensitive(False)
                updates_next2.set_sensitive(False)
            elif groups_page["UPDATES"] < max_page:
                updates_next1.set_sensitive(True)
                updates_next1.set_sensitive(True)
                updates_next1.connect("clicked", self.show_updates_packages, "next")
                updates_next2.connect("clicked", self.show_updates_packages, "next")
        else:
            groups_page["UPDATES"] = 0
            if len(query_updates_all) > 0:
                self.update_all_button.set_visible(True)
            else:
                self.update_all_button.set_visible(False)
            updates_page_box1.set_visible(False)
            updates_page_box2.set_visible(False)

        if len(packs) > 0:
            for i in range(0, len(packs)):
                template_button = self.create_button_from_packs(packs, i, False, True)
                listbox_results.insert(template_button, -1)
                self.stack.set_visible_child_name("updates")
                self.updates_stack.add_named(listbox, "updates_results_page")
                self.updates_stack.set_visible_child_name("updates_results_page")
                self.back.set_sensitive(True)
                self.back.show()
                self.home.show()
        else:
            if len(query_updates_all) > 0:
                    box = builder.get_object("updates_all_results")
                    self.updates_stack.add_named(box, "updates_all_results_page")
                    self.updates_stack.set_visible_child_name("updates_all_results_page")
                    groups_page["UPDATES"] = 0
                    updates_page_box1.set_visible(False)
                    updates_page_box2.set_visible(False)
                    self.update_all_button.set_visible(True)
                    self.stack.set_visible_child_name("updates")
                    self.back.set_sensitive(True)
                    self.back.show()
                    self.home.show()
            else:
                    self.status_image.show()
                    groups_page["UPDATES"] = 0

                    updates_page_box1.set_visible(False)
                    updates_page_box2.set_visible(False)
                    self.update_all_button.set_visible(False)
                    self.stack.set_visible_child_name("updates")
                    self.updates_stack.set_visible_child_name("updates_results_empty")
                    self.back.set_sensitive(True)
                    self.back.show()
                    self.home.show()

    def search_packages(self, button, page_flag, text):
        if text == "":
            text = self.search_entry.get_text()
            if ' ' in text:
                text = text.split(' ')[0]
                self.search_entry.set_text(text)
        if len(text) > 0:
            if self.app_page:
                try:
                    self.sub_stack.remove(self.app_page)
                except:
                    self.stack.remove(self.app_page)
                self.app_page.destroy()
                self.app_page = None
            if self.page_group:
                self.stack.remove(self.page_group)
                self.page_group.destroy()
                self.page_group = None
                self.blocked_button.set_sensitive(True)
                self.blocked_button = None

            if self.search_stack.get_visible_child_name() == "search_results_page":
                for child in self.search_stack.get_child_by_name("search_results_page"):
                    self.search_stack.get_child_by_name("search_results_page").remove(child)
                self.search_stack.remove(self.search_stack.get_child_by_name("search_results_page"))

            if self.installed_stack.get_visible_child_name() == "installed_results_page":
                for child in self.installed_stack.get_child_by_name("installed_results_page"):
                    self.installed_stack.get_child_by_name("installed_results_page").remove(child)
                self.installed_stack.remove(self.installed_stack.get_child_by_name("installed_results_page"))

            if self.updates_stack.get_visible_child_name() == "updates_results_page":
                for child in self.updates_stack.get_child_by_name("updates_results_page"):
                    self.updates_stack.get_child_by_name("updates_results_page").remove(child)
                self.updates_stack.remove(self.updates_stack.get_child_by_name("updates_results_page"))

            if page_flag == "zero":
                groups_page["SEARCH"] = 0
            elif page_flag == "next":
                groups_page["SEARCH"] += 1
            elif page_flag == "previous":
                groups_page["SEARCH"] -= 1
            text = text.lower()
            # self.search_entry.set_text("")
            # self.search_button.set_sensitive(False)
            builder = Gtk.Builder()
            if DEVEL_FLAG:
                builder.add_from_file('/home/wolandius/git_projects/redos_education/ui/templates.glade')
            else:
                builder.add_from_file('/opt/redos_education/ui/templates.glade')
            #
            listbox = builder.get_object("search_results")
            listbox_results = builder.get_object("box_search")

            groups_search = []
            global groups, groups_structure
            for group in groups_structure:
                for key in groups_structure[group]:
                    groups_search.append(key)

            packs, count, max_page = get_group_packages.get_search(text, groups_search, groups_page["SEARCH"])
            len_packs = len(packs)
            max_page -= 1 if max_page > 0 else 0

            search_pagebox1 = builder.get_object("page_box1")
            search_pagebox2 = builder.get_object("page_box3")

            search_prev1 = builder.get_object("prev_page1")
            search_prev2 = builder.get_object("prev_page3")
            search_next1 = builder.get_object("next_page1")
            search_next2 = builder.get_object("next_page3")

            if count > 24:
                search_pagebox1.set_visible(True)
                search_pagebox2.set_visible(True)
                if groups_page["SEARCH"] == 0:
                    search_prev1.set_sensitive(False)
                    search_prev2.set_sensitive(False)
                elif groups_page["SEARCH"] > 0:
                    search_prev1.set_sensitive(True)
                    search_prev2.set_sensitive(True)
                    search_prev1.connect("clicked", self.search_packages, "previous", text)
                    search_prev2.connect("clicked", self.search_packages, "previous", text)
                if groups_page["SEARCH"] == max_page:
                    search_next1.set_sensitive(False)
                    search_next2.set_sensitive(False)
                elif groups_page["SEARCH"] < max_page:
                    search_next1.set_sensitive(True)
                    search_next2.set_sensitive(True)
                    search_next1.connect("clicked", self.search_packages, "next", text)
                    search_next2.connect("clicked", self.search_packages, "next", text)
            else:
                groups_page["SEARCH"] = 0
                search_pagebox1.set_visible(False)
                search_pagebox2.set_visible(False)

            if len(packs) > 0:
                for i in range(0, len(packs)):
                    template_button = self.create_button_from_packs(packs, i, False, True)
                    listbox_results.insert(template_button, -1)
                    self.stack.set_visible_child_name("search")
                    self.search_stack.add_named(listbox, "search_results_page")
                    self.search_stack.set_visible_child_name("search_results_page")
                    self.back.set_sensitive(True)
                    self.back.show()
                    self.home.show()
            else:
                groups_page["SEARCH"] = 0
                search_pagebox1.set_visible(False)
                search_pagebox2.set_visible(False)
                self.stack.set_visible_child_name("search")
                self.search_stack.set_visible_child_name("search_results_empty")
                self.back.set_sensitive(True)
                self.back.show()
                self.home.show()
        else:
            pass

    def create_button_from_packs(self, packs, i, use_sub, hide_group_stack=False):
        PACKAGE_NAME = packs[i]['PACKAGE_NAME']
        ICON = packs[i]['ICON']
        ROWSTRIDE_ICON = packs[i]['ROWSTRIDE_ICON']
        HEIGHT_ICON = packs[i]['HEIGHT_ICON']
        WIDTH_ICON = packs[i]['WIDTH_ICON']
        ALPHA_IC = packs[i]['ALPHA_IC']
        BITS_IC = packs[i]['BITS_IC']
        APP_HUMANNAME = packs[i]['APP_HUMANNAME']

        template_button = self.create_app_button(PACKAGE_NAME=PACKAGE_NAME,
                                                 ICON=ICON,
                                                 ROWSTRIDE_ICON=ROWSTRIDE_ICON,
                                                 HEIGHT_ICON=HEIGHT_ICON,
                                                 WIDTH_ICON=WIDTH_ICON,
                                                 ALPHA_IC=ALPHA_IC,
                                                 BITS_IC=BITS_IC,
                                                 style="GtkListBoxRowRedButton",
                                                 use_sub=use_sub,
                                                 hide_group_stack=hide_group_stack,
                                                 APP_HUMANNAME=APP_HUMANNAME)
        return template_button

    def create_buttons(self, packs):
        len_packs = len(packs)
        for i in range(0, len_packs):
            # GtkBox = self.create_box_for_buttons()
            template_button = self.create_button_from_packs(packs, i, True)
            # GtkBox.pack_start(template_button, True, True, 3)
            # self.GtkListBox.pack_start(GtkBox, True, True, 3)
            self.GtkListBox.insert(template_button, -1)
        return False

    def open_page(self, button, name, check_blocked, all_name, sub_names, current_page, page_flag, hide_all=False, is_popup_button=False):
        global all_groups, groups
        if self.page_group:
            self.stack.remove(self.page_group)
        elif not self.blocked_button:
            if check_blocked:
                self.blocked_button = button
                button.set_sensitive(False)
        if is_popup_button:
            button.set_sensitive(True)

        self.group_actions_install = []
        self.group_actions_remove = []

        ## structure:
        # stack widget ID, current_visible_page_name
        self.group_buttons_stacks = []

        if page_flag == "zero":
            groups_page[name] = 0
        elif page_flag == "next":
            groups_page[name] += 1
        elif page_flag == "previous":
            groups_page[name] -= 1

        self.page_group, list, sub_list, self.sub_stack, self.sub_main_page, all_group_button, sub_groups_box = self.create_group_page()

        all_group_button.connect("clicked", self.open_page, all_name, False, all_name, sub_names, 0,
                                 "zero")
        if hide_all:
            all_group_button.hide()
            sub_groups_box.hide()
        self.buttons_for_block = [self.Menu, self.search_button, self.back, all_group_button, self.all_button,
                                  self.installed_button, self.updates_button, self.home, self.groupsmenubutton]


        for gname in sub_names:
            group, button = self.create_sub_group(gname)
            sub_list.add(group)
            button.connect("clicked", self.open_page, gname, False, all_name, sub_names, 0, "zero")
            self.buttons_for_block.append(button)

        # self.groupsmenubutton.hide()
        self.back.set_sensitive(True)

        self.GtkBoxVertical, self.GtkListBox, self.pagebox1, self.prev1, self.next1, self.pagebox2, \
        self.prev2, self.next2, self.apply_group_operations_button, self.group_actions_stack, \
        self.error_group_action_button, self.progress_bar_group_action  = self.create_group_label(name)


        GLib.timeout_add(60, self.on_progress_group_action_app, None)

        self.buttons_for_block.append(self.GtkBoxVertical)
        self.apply_group_operations_button.connect("clicked", self.on_apply_group_operations_button_clicked)

        name_array = []
        for parent in groups_structure:
            if len(groups_structure[parent]) > 1:
                if name == parent:
                    name_array = groups_structure[parent]
                    break
            else:
                name_array = [name]

        packs, count, max_page = get_group_packages.get_groups(name_array, groups_page[name],
                                                               is_group_page=True)

        max_page -= 1 if max_page > 0 else 0
        if count > 24:
            self.pagebox1.set_visible(True)
            self.pagebox2.set_visible(True)
            name = re.sub(" ", "_", name)
            if groups_page[name] == 0:
                self.prev1.set_sensitive(False)
                self.prev2.set_sensitive(False)
            else:
                self.prev1.connect("clicked", self.open_page, name, False, all_name, sub_names,
                                   groups_page[name], "previous")
                self.prev2.connect("clicked", self.open_page, name, False, all_name, sub_names,
                                   groups_page[name], "previous")
            if groups_page[name] == max_page:
                self.next1.set_sensitive(False)
                self.next2.set_sensitive(False)
            else:
                self.next1.connect("clicked", self.open_page, name, False, all_name, sub_names,
                                   groups_page[name], "next")
                self.next2.connect("clicked", self.open_page, name, False, all_name, sub_names,
                                   groups_page[name], "next")
        else:
            self.pagebox1.set_visible(False)
            self.pagebox2.set_visible(False)

        def thread_run():
            GLib.idle_add(self.create_buttons, packs)

        t = threading.Thread(target=thread_run)
        t.daemon = True
        t.start()

        while t.is_alive():
            self.stack.set_visible_child_name("wait")
        list.add(self.GtkBoxVertical)
        self.stack.set_visible_child(self.page_group)
        self.back.show()
        self.home.show()

    def on_apply_group_operations_button_clicked(self, button):
        do_actions = False
        if len(self.group_actions_remove) > 0:
            do_actions = True
        if len(self.group_actions_install) > 0:
            do_actions = True
        if do_actions:
            win = RedosStoreResolveDeps()
            out = os.popen("systemctl is-active redos-edu-dbus.service").readline().strip()
            if out == "inactive":
                the_dbus_starter.start()
            self.redos_dnf = bus.get("org.redos.edu.pydbus.RedosEdu", timeout=600)
            granted_access = self.redos_dnf.status_auth()
            if granted_access != "True":
                granted_access = self.redos_dnf.granteAuth(True)
            else:
                granted_access = "rules granted"
            install_specs = ""
            remove_specs = ""
            install_specs = " ".join(rpm for rpm in self.group_actions_install)
            remove_specs = " ".join(rpm for rpm in self.group_actions_remove)

            install, remove = self.redos_dnf.dependencies_group_action(install_specs, remove_specs)
            output = ""
            if install.strip() != "None":
                dependencies, errors = install.split("|||")

                if "Операция отменена" in errors or "Operation aborted" in errors or "Операция прервана" in errors:
                    dependencies = dependencies.split("\n")
                    key = -1
                    for i in range(0, len(dependencies)):
                        if "=" in dependencies[i]:
                            key = i
                            break
                    if key > -1:
                        dependencies = dependencies[key + 1:]

                    for i in range(0, len(dependencies)):
                        temp = dependencies[i].strip().split()

                        if len(temp) > 5:
                            dependencies[i] = f'\t{temp[0]}-{temp[2]}.{temp[1]} {temp[3]} {temp[4]}{temp[5]}'
                        elif len(temp) == 5:
                            dependencies[i] = f'\t{temp[0]}-{temp[2]}.{temp[1]} {temp[3]} {temp[4]}'
                        else:
                            dependencies[i] = f'<b> {dependencies[i]}</b>'
                        output += f"{dependencies[i]}\n"
            if remove != "None":
                dependencies, errors = remove.split("|||")
                if "Операция отменена" in errors or "Operation aborted" in errors or "Операция прервана" in errors:
                    dependencies = dependencies.split("\n")
                    key = -1
                    for i in range(0, len(dependencies)):
                        if "=" in dependencies[i]:
                            key = i
                            break
                    if key > -1:
                        dependencies = dependencies[key + 1:]
                    for i in range(0, len(dependencies)):
                        temp = dependencies[i].strip().split()
                        if len(temp) > 5:
                            dependencies[i] = f'\t{temp[0]}-{temp[2]}.{temp[1]} {temp[3]} {temp[4]}{temp[5]}'
                        elif len(temp) == 5:
                            dependencies[i] = f'\t{temp[0]}-{temp[2]}.{temp[1]} {temp[3]} {temp[4]}'
                        else:
                            if dependencies[i] != "":
                                dependencies[i] = f'<b> {dependencies[i]}</b>'
                        output += f"{dependencies[i]}\n"

            win.accept_button.connect("clicked", self.action_with_group, self.group_actions_stack, win
                                          )
            win.deny_button.connect("clicked", win.close_group_action, self.buttons_for_block,
                                   self.group_buttons_stacks, self.group_actions_install, self.group_actions_remove)

            win.window.connect("delete-event", win.custom_delete_group_action, self.buttons_for_block,
                                   self.group_buttons_stacks, self.group_actions_install, self.group_actions_remove)
            win.set_text(output)


    def action_with_group(self, button, stack, dep_window):
        self.stack_group = stack
        self.stack_group.set_visible_child_name("progress_page")
        dep_window.close_func()
        self.group_actions_stack.set_sensitive(True)
        self.group_actions_stack.set_visible_child_name("progress_page")
        for button_ in self.buttons_for_block:
            button_.set_sensitive(False)

        def action_with_groups_apps(*inputs):
            exit_code = "-1"
            if len(self.group_actions_install) > 0:
                self.spec_install = None
                self.spec_install = " ".join(rpm for rpm in self.group_actions_install)
                output = self.redos_dnf.group_install(self.spec_install.strip())
                exit_code = output

                if exit_code != "0":
                    return exit_code
            if len(self.group_actions_remove) > 0:
                self.spec_remove = None
                self.spec_remove = " ".join(rpm for rpm in self.group_actions_remove)
                exit_code = self.redos_dnf.group_remove(self.spec_remove)
            if exit_code == 0 or exit_code == "0":
                unload_dnf()
                recreate_dnf_base_query()
                return 0
            else:
                return exit_code
            return "0"

        def pass_callback(worker, result, handler_data):
            result = worker.return_value(result)
            if result == "0" or result == 0:
                self.stack_group.set_visible_child_name("apply_page")
                for button_ in self.buttons_for_block:
                    button_.set_sensitive(True)
                for i in range(0, len(self.group_buttons_stacks)):
                    if self.group_buttons_stacks[i][3] in self.group_actions_install or self.group_buttons_stacks[i][3] in self.group_actions_remove:
                        self.group_buttons_stacks[i][0].set_visible_child_name(self.group_buttons_stacks[i][2])
                        t_stack = self.group_buttons_stacks[i][2]
                        self.group_buttons_stacks[i][2] = self.group_buttons_stacks[i][1]
                        self.group_buttons_stacks[i][1] = t_stack

                self.group_actions_remove.clear()
                self.group_actions_install.clear()
            else:
                for button_ in self.buttons_for_block:
                    button_.set_sensitive(True)
                # self.error_group_action_button.connect("clicked")
                self.error_group_action_button.show()
                self.error_group_action_button.connect("clicked", self.show_error, f"{result}")

        inputs = ()
        async_worker = AsyncWorker(
            operation=action_with_groups_apps,
            operation_inputs=inputs,
            operation_callback=pass_callback
        )
        async_worker.start()

    def create_group_page(self):
        builder_template = Gtk.Builder()
        if DEVEL_FLAG:
            builder_template.add_from_file('/home/wolandius/git_projects/redos_education/ui/templates.glade')
        else:
            builder_template.add_from_file('/opt/redos_education/ui/templates.glade')
        #

        page = builder_template.get_object("group_page")
        self.stack.add_named(page, "group_page")
        list = builder_template.get_object("list_row_for_button")
        sub_list = builder_template.get_object("list_all_group")
        all_group_button = builder_template.get_object("all_group_button")
        all_group_button.get_children()[0].set_use_markup(True)
        all_group_button.get_children()[0].set_label(_("All"))
        sub_stack = builder_template.get_object("sub_stack")
        sub_main_page = builder_template.get_object("sub_main_page")
        sub_groups_box = builder_template.get_object("sub_groups_box")
        return [page, list, sub_list, sub_stack, sub_main_page, all_group_button, sub_groups_box]

    def create_sub_group(self, name, translate=None):
        builder_template = Gtk.Builder()
        if DEVEL_FLAG:
            builder_template.add_from_file('/home/wolandius/git_projects/redos_education/ui/templates.glade')
        else:
            builder_template.add_from_file('/opt/redos_education/ui/templates.glade')
        #

        row = builder_template.get_object("row_sub_group")
        button = builder_template.get_object("sub_group_button")
        button.get_children()[0].set_use_markup(True)

        get_translate = groups_page_translations[name]
        button.get_children()[0].set_label(get_translate)
        return [row, button]

    def create_box_for_buttons(self):
        builder_template = Gtk.Builder()
        if DEVEL_FLAG:
            builder_template.add_from_file('/home/wolandius/git_projects/redos_education/ui/templates.glade')
        else:
            builder_template.add_from_file('/opt/redos_education/ui/templates.glade')
        #

        box = builder_template.get_object("box_for_other_buttons")
        return box

    def create_group_label(self, groupname="TestGroup"):
        builder_template = Gtk.Builder()
        if DEVEL_FLAG:
            builder_template.add_from_file('/home/wolandius/git_projects/redos_education/ui/templates.glade')
        else:
            builder_template.add_from_file('/opt/redos_education/ui/templates.glade')
        #
        box = builder_template.get_object("groupnamebox")
        label = builder_template.get_object("groupname_label")
        # groupname = groupname.upper()
        # groupname = re.sub(" ", "_", groupname)
        get_translate = groups_page_translations[groupname]
        label.set_text(get_translate)
        label.set_text(get_translate)
        listbox = builder_template.get_object("list_for_other_buttons")
        pagebox1 = builder_template.get_object("page_box")
        prev1 = builder_template.get_object("prev_page")
        next1 = builder_template.get_object("next_page")
        pagebox2 = builder_template.get_object("page_box2")
        prev2 = builder_template.get_object("prev_page2")
        next2 = builder_template.get_object("next_page2")
        apply_group_operations = builder_template.get_object("apply_group_operations")
        group_actions_stack = builder_template.get_object("group_actions_stack")
        error_group_action_button = builder_template.get_object("error_group_action_button")
        progress_bar_group_action = builder_template.get_object("progress_bar_group_action")
        return [box, listbox, pagebox1, prev1, next1, pagebox2, prev2, next2, apply_group_operations,
                group_actions_stack, error_group_action_button, progress_bar_group_action]

    def create_app_button(self, **kwargs):
        # print(kwargs)
        if kwargs.get("PACKAGE_NAME"):
            PACKAGE_NAME = kwargs.get("PACKAGE_NAME")
        APP_HUMANNAME = kwargs.get("APP_HUMANNAME") if kwargs.get("APP_HUMANNAME") else None
        ICON = kwargs.get("ICON") if kwargs.get("ICON") else None

        ROWSTRIDE_ICON = kwargs.get("ROWSTRIDE_ICON") if kwargs.get("ROWSTRIDE_ICON") else None

        HEIGHT_ICON = kwargs.get("HEIGHT_ICON") if kwargs.get("HEIGHT_ICON") else None

        WIDTH_ICON = kwargs.get("WIDTH_ICON")if kwargs.get("WIDTH_ICON") else None

        ALPHA_IC = kwargs.get("ALPHA_IC") if kwargs.get("ALPHA_IC") else None

        BITS_IC = kwargs.get("BITS_IC") if kwargs.get("BITS_IC") else None

        hide_group_stack = kwargs.get("hide_group_stack") if kwargs.get("hide_group_stack") else False

        if kwargs.get("style"):
            style = kwargs.get("style")
        use_sub = True if kwargs.get("use_sub") else False

        package_info = get_group_packages.get_package_info(PACKAGE_NAME)
        if locale.getdefaultlocale()[0] == 'ru_RU':
            S_DESC = package_info['S_DESC_RU'] if package_info['S_DESC_RU'] else package_info['S_DESC_ENG']
        else:
            S_DESC = package_info['S_DESC_ENG']
        builder_template = Gtk.Builder()
        if DEVEL_FLAG:
            builder_template.add_from_file('/home/wolandius/git_projects/redos_education/ui/templates.glade')
        else:
            builder_template.add_from_file('/opt/redos_education/ui/templates.glade')

        button = builder_template.get_object("app_button")
        button.get_style_context().add_class(style)
        button_action = builder_template.get_object("appbutton_action")
        button_action.connect("clicked", self.open_app_page,
                              PACKAGE_NAME,
                              ICON, ROWSTRIDE_ICON, HEIGHT_ICON, WIDTH_ICON, ALPHA_IC, BITS_IC,
                              use_sub
                              )
        GtkImage = builder_template.get_object("app_image")

        try:
            pixbuf = GdkPixbuf.Pixbuf.new_from_data(
                ICON,
                GdkPixbuf.Colorspace.RGB, ALPHA_IC, BITS_IC,
                WIDTH_ICON, HEIGHT_ICON, ROWSTRIDE_ICON
            )
            
            GtkImage.set_from_pixbuf(pixbuf)

            if WIDTH_ICON > 96:
                GtkImage.set_pixel_size(96)

        except Exception as e:
            try:
                GtkImage.set_from_icon_name("application-x-executable", 6)
                GtkImage.set_pixel_size(96)
            except:
                GtkImage.set_from_icon_name("application-default-icon", 6)
                GtkImage.set_pixel_size(96)

        GtkLabel = builder_template.get_object("app_label")
        GtkLabel.set_markup(f"<b>{APP_HUMANNAME}</b>") if APP_HUMANNAME else GtkLabel.set_markup(f"<b>{PACKAGE_NAME}</b>")
        builder_template.get_object("app_label_sdesc").set_markup(f"{S_DESC}")
        group_button_stack = builder_template.get_object("group_buttons_stack")
        if hide_group_stack:
            group_button_stack.hide()
        else:

            query_installed = create_query("installed", PACKAGE_NAME).latest().run()
            if len(query_installed) > 0:
                group_button_stack.set_visible_child_name("remove_in_group")
                builder_template.get_object("remove_in_group").connect("clicked",
                                                                       self.add_to_group_action_remove,
                                                                       PACKAGE_NAME,
                                                                       group_button_stack,
                                                                       builder_template.get_object("status_label"))
                builder_template.get_object("install_in_group").connect("clicked",
                                                                        self.add_to_group_action_install,
                                                                        PACKAGE_NAME,
                                                                        group_button_stack,
                                                                        builder_template.get_object("status_label"))
                if hasattr(self, 'group_buttons_stacks'):
                    self.group_buttons_stacks.append([group_button_stack, "remove_in_group", "install_in_group", PACKAGE_NAME])
            else:
                group_button_stack.set_visible_child_name("install_in_group")
                builder_template.get_object("install_in_group").connect("clicked",
                                                                        self.add_to_group_action_install,
                                                                        PACKAGE_NAME,
                                                                        group_button_stack,
                                                                        builder_template.get_object("status_label"))
                builder_template.get_object("remove_in_group").connect("clicked",
                                                                       self.add_to_group_action_remove,
                                                                       PACKAGE_NAME,
                                                                       group_button_stack,
                                                                       builder_template.get_object("status_label"))
                if hasattr(self, 'group_buttons_stacks'):
                    self.group_buttons_stacks.append([group_button_stack, "install_in_group", "remove_in_group", PACKAGE_NAME])

        return button

    def add_to_group_action_install(self, button, PACKAGE_NAME, stack, label):
        if PACKAGE_NAME not in self.group_actions_install:
            spec = f"{PACKAGE_NAME}"
            self.group_actions_install.append(spec)
            stack.set_visible_child_name("status_label")
            text = _('Click <b>Apply</b> to complete the installation')
            label.set_markup(f"{text}")

    def add_to_group_action_remove(self, button, PACKAGE_NAME, stack, label):
        print(PACKAGE_NAME)
        if PACKAGE_NAME not in self.group_actions_remove:
            spec = f"{PACKAGE_NAME}"
            self.group_actions_remove.append(spec)
            stack.set_visible_child_name("status_label")
            text = _('Click <b>Apply</b> to complete the removal')
            label.set_markup(f"{text}")


    def open_app_page(self, button,
                      PACKAGE_NAME, ICON=None,
                      ROWSTRIDE_ICON=None, HEIGHT_ICON=None, WIDTH_ICON=None, ALPHA_IC=None, BITS_IC=None,
                      use_sub=True
                      ):
        self.action_with_app_name = None
        package_info = get_group_packages.get_package_info(PACKAGE_NAME)
        query_available = create_query("available", PACKAGE_NAME).latest().run()
        query_installed = create_query("installed", PACKAGE_NAME).latest().run()
        query_updates = create_query("updates", PACKAGE_NAME).latest().run()
        # self.groupsmenubutton.hide()
        if len(query_available) > 0:
            for pkg in query_available:
                rpm = pkg
                nevra_string = str(rpm)
                subject = dnf.subject.Subject(nevra_string)
                possible_nevra = subject.get_nevra_possibilities(
                    forms=[hawkey.FORM_NEVRA, hawkey.FORM_NEVR])
                for notnevra, nevra in enumerate(possible_nevra):
                    if str(nevra.arch) != "None":
                        DOWNLOAD_SIZE = int(int(getattr(rpm, 'downloadsize')) / 1024)
                        INSTALL_SIZE = int(int(getattr(rpm, 'installsize')) / 1024)
                        LICENSE = str(getattr(rpm, 'license'))
                        REPONAME = str(getattr(rpm, 'reponame'))
                        CHANGELOGS = build_format_fn(opts_changelogs, rpm)
                        VERSION = str(nevra.version).strip()
                        RELEASE_VER = str(nevra.release).strip()
                        EPOCH = None
                        if nevra.epoch:
                            EPOCH = str(nevra.epoch).strip()
        desktops = []
        if len(query_installed) > 0:
            for pkg in query_installed:
                rpm = pkg
                nevra_string = str(rpm)
                subject = dnf.subject.Subject(nevra_string)
                possible_nevra = subject.get_nevra_possibilities(
                    forms=[hawkey.FORM_NEVRA, hawkey.FORM_NEVR])
                for notnevra, nevra in enumerate(possible_nevra):
                    if str(nevra.arch) != "None":
                        po = PackageWrapper(rpm)
                        filelists = po.files
                        if filelists:
                            filelists = filelists.split("\n")
                            for f in filelists:
                                if ".desktop" in f:

                                    NoDisplay = get_artibute_from_desktop(path=f, section="Desktop Entry",
                                                                     setting="NoDisplay")
                                    # print(f, NoDisplay)
                                    if NoDisplay == "" or NoDisplay is None:
                                        desktops.append(f)
                        if versiontuple(VERSION) != versiontuple(str(nevra.version).strip()):
                            VERSION = str(nevra.version).strip()
                            try:
                                REPONAME = str(getattr(rpm, "_from_repo"))
                                REPONAME = re.sub("@", "", REPONAME)
                            except:
                                try:
                                    REPONAME = str(getattr(rpm, 'reponame'))
                                except:
                                    REPONAME = ""

                            RELEASE_VER = str(nevra.release).strip()
                            EPOCH = None
                            if nevra.epoch:
                                EPOCH = str(nevra.epoch).strip()

        builder_template = Gtk.Builder()
        if DEVEL_FLAG:
            builder_template.add_from_file('/home/wolandius/git_projects/redos_education/ui/templates.glade')
        else:
            builder_template.add_from_file('/opt/redos_education/ui/templates.glade')
        self.button_stack = builder_template.get_object("for_buttons_stack")
        if len(query_updates) > 0:
            self.button_stack.set_visible_child_name("update_page")
        elif len(query_installed) > 0:
            self.button_stack.set_visible_child_name("delete_page")
        else:
            self.button_stack.set_visible_child_name("install_page")
        if locale.getdefaultlocale()[0] == 'ru_RU':
            S_DESC = package_info['S_DESC_RU'] if package_info['S_DESC_RU'] else package_info['S_DESC_ENG']
            F_DESC = package_info['F_DESC_RU'] if package_info['F_DESC_RU'] else package_info['F_DESC_ENG']
        else:
            S_DESC = package_info['S_DESC_ENG']
            F_DESC = package_info['S_DESC_ENG']

        PICTURE1 = package_info['PICTURE1']
        ROWSTRIDE_PIC1 = package_info['ROWSTRIDE_PIC1']
        HEIGHT_PIC1 = package_info['HEIGHT_PIC1']
        WIDTH_PIC1 = package_info['WIDTH_PIC1']
        ALPHA_PIC1 = package_info['ALPHA_PIC1']
        BITS_PIC1 = package_info['BITS_PIC1']

        PICTURE2 = package_info['PICTURE2']
        ROWSTRIDE_PIC2 = package_info['ROWSTRIDE_PIC2']
        HEIGHT_PIC2 = package_info['HEIGHT_PIC2']
        WIDTH_PIC2 = package_info['WIDTH_PIC2']
        ALPHA_PIC2 = package_info['ALPHA_PIC2']
        BITS_PIC2 = package_info['BITS_PIC2']

        PICTURE3 = package_info['PICTURE3']
        ROWSTRIDE_PIC3 = package_info['ROWSTRIDE_PIC3']
        HEIGHT_PIC3 = package_info['HEIGHT_PIC3']
        WIDTH_PIC3 = package_info['WIDTH_PIC3']
        ALPHA_PIC3 = package_info['ALPHA_PIC3']
        BITS_PIC3 = package_info['BITS_PIC3']

        APP_HUMANNAME = package_info['APP_HUMANNAME']
        self.app_page = builder_template.get_object("app_page")

        self.application_page = self.app_page
        self.progress_bar = builder_template.get_object("progress_bar")

        f_desc_label = builder_template.get_object("full_desc_label")
        self.changelogs_label = builder_template.get_object("changelogs_label")
        self.back.set_sensitive(True)
        f_desc_label.set_text(re.sub("`", "'", str(F_DESC.strip())))

        app_name = builder_template.get_object("app_name_label")
        package_name = _('Package name')
        app_name.set_markup(f"{package_name}: {APP_HUMANNAME}") if APP_HUMANNAME else \
            app_name.set_markup(f"{package_name}: {PACKAGE_NAME}")
        self.launch_stack = builder_template.get_object("launch_stack")
        self.launch_stack.hide()
        self.launch_stack1 = builder_template.get_object("launch_stack1")
        self.launch_stack1.hide()
        self.launchmenubox = builder_template.get_object("launchmenubox")
        self.launch_popover_button = builder_template.get_object("launch_popover_button")
        self.launch_popover_button1 = builder_template.get_object("launch_popover_button1")
        self.launch_popover_button.set_label(_("Launch"))
        if DEVEL_FLAG:
            self.launch_popover_button.set_image(Gtk.Image.new_from_file("/home/wolandius/git_projects/redos_education/ui/arrow-down.svg"))
        else:
            self.launch_popover_button.set_image(Gtk.Image.new_from_file("/opt/redos_education/ui/arrow-down.svg"))
        self.launch_popover_button.set_always_show_image(True)

        self.launch_popover_button1.set_label(_("Launch"))
        if DEVEL_FLAG:
            self.launch_popover_button1.set_image(Gtk.Image.new_from_file("/home/wolandius/git_projects/redos_education/ui/arrow-down.svg"))
        else:
            self.launch_popover_button1.set_image(Gtk.Image.new_from_file("/opt/redos_education/ui/arrow-down.svg"))
        self.launch_popover_button1.set_always_show_image(True)


        self.launch_button = builder_template.get_object("launch_button")
        self.launch_button1 = builder_template.get_object("launch_button1")
        # self.launch_button.hide()
        # self.launch_button1.hide()

        if len(desktops) == 1:
            exec = get_artibute_from_desktop(path=desktops[0], section="Desktop Entry", setting="Exec")
            if exec:
                self.launch_stack.show()
                self.launch_stack.set_visible_child_name("page_launch_button")
                self.launch_stack1.show()
                self.launch_stack1.set_visible_child_name("page_launch_button")

                self.launch_button.connect("clicked", self.on_exec_button_clicked, exec)
                self.launch_button1.connect("clicked", self.on_exec_button_clicked, exec)
        elif len(desktops) > 1:
            self.launch_stack.show()
            self.launch_stack.set_visible_child_name("page_launch_popover")
            self.launch_stack1.show()
            self.launch_stack1.set_visible_child_name("page_launch_popover")
            for desktop in desktops:
                builder_template_rows = Gtk.Builder()
                if DEVEL_FLAG:
                    builder_template_rows.add_from_file('/home/wolandius/git_projects/redos_education/ui/templates.glade')
                else:
                    builder_template_rows.add_from_file('/opt/redos_education/ui/templates.glade')


                grouprow = builder_template_rows.get_object(f"grouprow")
                if locale.getdefaultlocale()[0] == 'ru_RU':
                    desktopName = get_artibute_from_desktop(path=desktop, section="Desktop Entry", setting="Name[ru]")
                    if desktopName == "" or desktopName is None:
                        desktopName = get_artibute_from_desktop(path=desktop, section="Desktop Entry", setting="Name")
                else:
                    desktopName = get_artibute_from_desktop(path=desktop, section="Desktop Entry", setting="Name")
                exec = get_artibute_from_desktop(path=desktop, section="Desktop Entry", setting="Exec")
                grouprow.set_name(f"{desktopName}")
                self.launchmenubox.add(grouprow)
                more_group_menu = builder_template_rows.get_object("more_group_menu")
                more_group_menu.set_label(desktopName)
                more_group_menu.connect("clicked", self.on_exec_button_clicked, exec)

        # short_desc = builder_template.get_object("short_desc_label")
        self.size_label = builder_template.get_object("size_label")
        license_label = builder_template.get_object("license_label")
        # short_desc.set_text(f"{str(S_DESC.strip())}")

        reponame_label = builder_template.get_object("reponame")
        repo_str = _('Repository')
        lic_str = _('License')
        ver_str = _('Version')
        d_size_str = _('Download size')
        f_size_str = _('Changes size')
        human_repo_name = ""

        for filename in os.listdir("/etc/yum.repos.d/"):
            if filename.endswith(".repo"):
                if REPONAME in get_sections(f"/etc/yum.repos.d/{str(filename)}"):
                    human_repo_name = get_artibute(path=f"/etc/yum.repos.d/{str(filename)}", section=REPONAME,
                                                       setting="name")
                    break

        if human_repo_name != "" or human_repo_name:
            reponame_label.set_text(f"{repo_str}: {str(human_repo_name)}")
        else:
            reponame_label.set_text(f"{repo_str}: {str(REPONAME)}")

        license_label.set_text(f"{lic_str}: {LICENSE}")

        if EPOCH:
            self.size_label.set_text(f"{ver_str}: {str(EPOCH)}:{str(VERSION)}-{str(RELEASE_VER)}\n"
                                f"{d_size_str}: {DOWNLOAD_SIZE}Kb\n"
                                f"{f_size_str}: {INSTALL_SIZE}Kb")

        else:
            self.size_label.set_text(f"{ver_str}: {str(VERSION)}-{str(RELEASE_VER)}\n"
                                f"{d_size_str}: {DOWNLOAD_SIZE}Kb\n"
                                f"{f_size_str}: {INSTALL_SIZE}Kb")

        self.changelogs_label.set_text(CHANGELOGS.strip())

        app_not_installed = True
        no_updates = True
        if EPOCH:
            appversion = f"{EPOCH}:{VERSION}-{RELEASE_VER}"
        else:
            appversion = f"{VERSION}-{RELEASE_VER}"
        GLib.timeout_add(60, self.on_progress_action_app, None)

        self.button_update = builder_template.get_object("update_button")
        self.button_update.connect("clicked", self.resolve_deps,
                                   "update", self.button_stack,
                                   str(PACKAGE_NAME), str(VERSION),
                                   EPOCH, RELEASE_VER)

        self.button_delete = builder_template.get_object("delete_button")
        self.button_delete.connect("clicked", self.resolve_deps,
                                   "remove", self.button_stack,
                                   str(PACKAGE_NAME), str(VERSION),
                                   EPOCH, RELEASE_VER)

        self.button_delete1 = builder_template.get_object("delete_button1")
        self.button_delete1.connect("clicked", self.resolve_deps,
                                   "remove", self.button_stack,
                                   str(PACKAGE_NAME), str(VERSION),
                                   EPOCH, RELEASE_VER)

        self.button_install = builder_template.get_object("install_button")
        self.button_install.connect("clicked", self.resolve_deps,
                                    "install", self.button_stack,
                                    str(PACKAGE_NAME), str(VERSION), EPOCH,
                                    RELEASE_VER)

        self.button_error = builder_template.get_object("error_button")

        GtkImage = builder_template.get_object("app_icon")
        try:
            pixbuf = GdkPixbuf.Pixbuf.new_from_data(
                ICON,
                GdkPixbuf.Colorspace.RGB, ALPHA_IC, BITS_IC,
                WIDTH_ICON, HEIGHT_ICON, ROWSTRIDE_ICON
            )
            GtkImage.set_from_pixbuf(pixbuf)
        except Exception as e:
            # print(e)
            try:
                GtkImage.set_from_icon_name("application-x-executable", 6)
                GtkImage.set_pixel_size(96)
            except:
                GtkImage.set_from_icon_name("application-default-icon", 6)
                GtkImage.set_pixel_size(96)
        pictures = 0
        if PICTURE1 or PICTURE2 or PICTURE3:
            self.image_stack = builder_template.get_object("image_stack")
            if PICTURE1:
                pictures += 1
                self.pic1_obj = builder_template.get_object("application_live_image1")
                pixbuf = GdkPixbuf.Pixbuf.new_from_data(
                    PICTURE1,
                    GdkPixbuf.Colorspace.RGB, ALPHA_PIC1, BITS_PIC1,
                    WIDTH_PIC1, HEIGHT_PIC1, ROWSTRIDE_PIC1
                )
                self.pic1_obj.set_from_pixbuf(pixbuf)
                self.image_stack.add_named(self.pic1_obj, "pic1_obj")
                self.image_stack.set_visible_child_name("pic1_obj")
            if PICTURE2:
                pictures += 1
                self.pic2_obj = builder_template.get_object("application_live_image2")
                pixbuf = GdkPixbuf.Pixbuf.new_from_data(
                    PICTURE2,
                    GdkPixbuf.Colorspace.RGB, ALPHA_PIC2, BITS_PIC2,
                    WIDTH_PIC2, HEIGHT_PIC2, ROWSTRIDE_PIC2
                )
                self.pic2_obj.set_from_pixbuf(pixbuf)
            if PICTURE3:
                pictures += 1
                self.pic3_obj = builder_template.get_object("application_live_image3")
                pixbuf = GdkPixbuf.Pixbuf.new_from_data(
                    PICTURE3,
                    GdkPixbuf.Colorspace.RGB, ALPHA_PIC3, BITS_PIC3,
                    WIDTH_PIC3, HEIGHT_PIC3, ROWSTRIDE_PIC3
                )
                self.pic3_obj.set_from_pixbuf(pixbuf)
            self.go_next = builder_template.get_object("go_next")
            self.go_prev = builder_template.get_object("go_prev")
            if pictures == 1:
                self.go_next.set_visible(False)
                self.go_prev.set_visible(False)
            else:
                self.go_next.connect("clicked", self.change_picture_next, pictures)
                self.go_prev.connect("clicked", self.change_picture_prev, pictures)
        else:
            image_box = builder_template.get_object("image_box")
            image_box.hide()
        self.back.show()
        self.home.show()
        if use_sub:
            self.sub_stack.add_named(self.app_page, "app_page")
            self.sub_stack.set_visible_child_name("app_page")
            self.stack.set_visible_child_name("group_page")
            # self.buttons_for_block = [self.Menu, self.search_button, self.back, self.all_button, self.installed_button, self.updates_button]
        else:
            self.stack.add_named(self.app_page, "app_page")
            self.stack.set_visible_child_name("app_page")
            self.buttons_for_block = [self.Menu, self.search_button, self.back, self.all_button, self.installed_button,
                                      self.updates_button, self.home, self.button_update, self.button_install,
                                      self.button_delete, self.groupsmenubutton]

    def on_progress_action_app(self, user_data):
        self.progress_bar.pulse()
        return True

    def on_progress_group_action_app(self, user_data):
            self.progress_bar_group_action.pulse()
            return True


    def on_exec_button_clicked(self, button, exec):
        def func_exec(*inputs):
            os.system(inputs[0])
            return 0

        def pass_callback(worker, result, handler_data):
            result = worker.return_value(result)

        inputs = [exec]
        async_worker = AsyncWorker(
            operation=func_exec,
            operation_inputs=inputs,
            operation_callback=pass_callback
        )
        async_worker.start()

    def change_picture_next(self, button, pictures):
        if pictures == 3:
            if self.image_stack.get_visible_child_name() == "pic1_obj":
                self.image_stack.remove(self.pic1_obj)
                self.image_stack.add_named(self.pic2_obj, "pic2_obj")
                self.image_stack.set_visible_child_name("pic2_obj")

            elif self.image_stack.get_visible_child_name() == "pic2_obj":
                self.image_stack.remove(self.pic2_obj)
                self.image_stack.add_named(self.pic3_obj, "pic3_obj")
                self.image_stack.set_visible_child_name("pic3_obj")

            elif self.image_stack.get_visible_child_name() == "pic3_obj":
                self.image_stack.remove(self.pic3_obj)
                self.image_stack.add_named(self.pic1_obj, "pic1_obj")
                self.image_stack.set_visible_child_name("pic1_obj")
        elif pictures == 2:
            if self.image_stack.get_visible_child_name() == "pic1_obj":
                self.image_stack.remove(self.pic1_obj)
                self.image_stack.add_named(self.pic2_obj, "pic2_obj")
                self.image_stack.set_visible_child_name("pic2_obj")

            elif self.image_stack.get_visible_child_name() == "pic2_obj":
                self.image_stack.remove(self.pic2_obj)
                self.image_stack.add_named(self.pic1_obj, "pic1_obj")
                self.image_stack.set_visible_child_name("pic1_obj")

    def change_picture_prev(self, button, pictures):
        if pictures == 3:
            if self.image_stack.get_visible_child_name() == "pic1_obj":
                self.image_stack.remove(self.pic1_obj)
                self.image_stack.add_named(self.pic3_obj, "pic3_obj")
                self.image_stack.set_visible_child_name("pic3_obj")

            elif self.image_stack.get_visible_child_name() == "pic3_obj":
                self.image_stack.remove(self.pic3_obj)
                self.image_stack.add_named(self.pic2_obj, "pic2_obj")
                self.image_stack.set_visible_child(self.pic2_obj)

            elif self.image_stack.get_visible_child_name() == "pic2_obj":
                self.image_stack.remove(self.pic2_obj)
                self.image_stack.add_named(self.pic1_obj, "pic1_obj")
                self.image_stack.set_visible_child(self.pic1_obj)

        elif pictures == 2:
            if self.image_stack.get_visible_child_name() == "pic1_obj":
                self.image_stack.remove(self.pic1_obj)
                self.image_stack.add_named(self.pic2_obj, "pic2_obj")
                self.image_stack.set_visible_child(self.pic2_obj)
            elif self.image_stack.get_visible_child_name() == "pic2_obj":
                self.image_stack.remove(self.pic2_obj)
                self.image_stack.add_named(self.pic1_obj, "pic1_obj")
                self.image_stack.set_visible_child(self.pic1_obj)

    def resolve_deps(self, button, command, stack, package_name, version, epoch, release_ver):
        self.previous_stack = self.button_stack.get_visible_child_name()

        # self.progress_bar.pulse()
        if not epoch:
            epoch = "None"
        out = os.popen("systemctl is-active redos-edu-dbus.service").readline().strip()
        if out == "inactive":
            the_dbus_starter.start()
        self.redos_dnf = bus.get("org.redos.edu.pydbus.RedosEdu", timeout=600)
        granted_access = self.redos_dnf.status_auth()
        if granted_access != "True":
            granted_access = self.redos_dnf.granteAuth(True)
        else:
            granted_access = "rules granted"
        if granted_access == "rules granted":
            for button_ in self.buttons_for_block:
                button_.set_sensitive(False)
            self.button_stack.set_sensitive(False)
            win = RedosStoreResolveDeps()
            dependencies, errors = self.redos_dnf.dependencies_check(package_name, version, epoch, release_ver, command).split("|||")
            if "Операция отменена" in errors or "Operation aborted" in errors or "Операция прервана" in errors:
                dependencies = dependencies.split("\n")
                output = ""
                key = -1
                for i in range (0, len(dependencies)):
                    if "=" in dependencies[i]:
                        key = i
                        break
                if key > -1:
                    dependencies = dependencies[key+1:]
                for i in range(0, len(dependencies)):
                    temp = dependencies[i].strip().split()

                    if len(temp) > 5:
                        dependencies[i] = f'\t{temp[0]}-{temp[2]}.{temp[1]} {temp[3]} {temp[4]}{temp[5]}'
                    elif len(temp) == 5:
                        dependencies[i] = f'\t{temp[0]}-{temp[2]}.{temp[1]} {temp[3]} {temp[4]}'
                    else:
                        dependencies[i] = f'<b> {dependencies[i]}</b>'
                    output += f"{dependencies[i]}\n"
                win.accept_button.connect("clicked", self.action_with_app,
                                          command, self.button_stack,
                                          package_name, version,
                                          epoch, release_ver, win)
                win.deny_button.connect("clicked", win.close, self.buttons_for_block, command, self.button_stack, self.previous_stack)
                win.window.connect("delete-event", win.custom_delete, self.buttons_for_block, command, self.button_stack, self.previous_stack)
                win.set_text(output)
            else:
                for button_ in self.buttons_for_block:
                    button_.set_sensitive(True)
                self.set_error(errors)
                win.close_func()
        elif granted_access == "rules not granted":
            # self.progress_bar.set_fraction(self.progress_bar.get_fraction() - 0.25)
            page_name = ""
            if command == "remove":
                page_name = "delete_page"
            elif command == "install":
                page_name = "install_page"
            elif command == "update":
                page_name = "update_page"
            self.button_stack.set_visible_child_name(page_name)

    def action_with_app(self, button, command, stack, package_name, version, epoch, release_ver, dep_window
                        ):
        self.button_stack.set_sensitive(True)
        self.button_stack.set_visible_child_name("progress_page")
        if command == "remove":
            self.progress_bar.set_text(_(f"Prepare to remove"))
        elif command == "install":
            self.progress_bar.set_text(_(f"Prepare to install"))
        elif command == "update":
            self.progress_bar.set_text(_(f"Prepare to update"))
        self.progress_bar.pulse()
        dep_window.close_func()

        for button_ in self.buttons_for_block:
            button_.set_sensitive(False)
        if command == "install":
            self.progress_bar.set_text(_("Installing"))
            # self.progress_bar.set_fraction(self.progress_bar.get_fraction() + 0.5)
            def action_with_app(*inputs):
                exit_code_phase1 = self.redos_dnf.install(package_name, version, epoch, release_ver)
                if exit_code_phase1 == "0":
                    unload_dnf()
                    recreate_dnf_base_query()
                    return 0
                else:
                    return exit_code_phase1

            def pass_callback(worker, result, handler_data):
                result = worker.return_value(result)
                if result == 0 or result == "0":
                    self.cli_update_cache(stack, package_name, self.progress_bar, self.button_error)
                    self.action_with_app_name = package_name

                    for button_ in self.buttons_for_block:
                        button_.set_sensitive(True)
                    self.redos_dnf = None
                else:
                    for button_ in self.buttons_for_block:
                        button_.set_sensitive(True)
                    self.set_error(f"{result}")
        elif command == "remove":
            self.progress_bar.set_text(_("Removing"))
            # self.progress_bar.set_fraction(self.progress_bar.get_fraction() + 0.5)
            def action_with_app(*inputs):
                exit_code_phase1 = self.redos_dnf.remove(package_name, version, epoch, release_ver)

                if exit_code_phase1 == "0":
                    unload_dnf()
                    recreate_dnf_base_query()
                    return 0
                else:
                    return exit_code_phase1

            def pass_callback(worker, result, handler_data):
                result = worker.return_value(result)
                if result == 0 or result == "0":
                    self.cli_update_cache(stack, package_name, self.progress_bar, self.button_error)
                    self.action_with_app_name = package_name

                    for button_ in self.buttons_for_block:
                        button_.set_sensitive(True)
                    self.redos_dnf = None
                else:
                    for button_ in self.buttons_for_block:
                        button_.set_sensitive(True)
                    self.set_error(f"{result}")

        elif command == "update":
            self.progress_bar.set_text(_("Updating"))
            # self.progress_bar.set_fraction(self.progress_bar.get_fraction() + 0.5)

            def action_with_app(*inputs):
                exit_code_phase1 = self.redos_dnf.update(package_name, version, epoch, release_ver)
                if exit_code_phase1 == "0":
                    unload_dnf()
                    recreate_dnf_base_query()
                    return 0
                else:
                    return exit_code_phase1

            def pass_callback(worker, result, handler_data):
                result = worker.return_value(result)
                if result == 0 or result == "0":
                    self.cli_update_cache(stack, package_name, self.progress_bar, self.button_error)
                    for button_ in self.buttons_for_block:
                        button_.set_sensitive(True)
                    self.redos_dnf = None
                else:
                    for button_ in self.buttons_for_block:
                        button_.set_sensitive(True)
                    self.set_error(f"{result}")

        inputs = ()
        async_worker = AsyncWorker(
            operation=action_with_app,
            operation_inputs=inputs,
            operation_callback=pass_callback
        )
        async_worker.start()

    def action_upd_all(self, button, stack, stack_block, dep_window):
        dep_window.close_func()
        for button_ in self.buttons_for_block:
            button_.set_sensitive(False)
        self.progress_update_bar.set_text(_("Updating"))
        # self.progress_update_bar.set_fraction(self.progress_update_bar.get_fraction() + 0.5)

        def action_with_rpms(*inputs):
            exit_code_phase1 = self.redos_dnf.update_all()
            if exit_code_phase1 == "0":
                unload_dnf()
                recreate_dnf_base_query()
                return "0"
            else:
                return exit_code_phase1

        def pass_callback(worker, result, handler_data):
            result = worker.return_value(result)
            if result == "0":
                self.progress_update_bar.set_text(_("Cache update"))
                # self.progress_update_bar.set_fraction(self.progress_update_bar.get_fraction() + 0.10)
                create_updates_list()
                self.progress_update_bar.set_text(_("Done"))
                # self.progress_update_bar.set_fraction(self.progress_update_bar.get_fraction() + 0.15)
                for button_ in self.buttons_for_block:
                    button_.set_sensitive(True)
                stack_block.set_sensitive(True)
                stack.set_visible_child_name("update_page")
                self.updates_button.clicked()
                self.redos_dnf = None
            else:
                win = RedosStoreError()
                win.set_text(f"{result}", stack, stack_block,
                                        self.buttons_for_block, self.progress_update_bar)

        inputs = ()
        async_worker = AsyncWorker(
            operation=action_with_rpms,
            operation_inputs=inputs,
            operation_callback=pass_callback
        )
        async_worker.start()


    def set_error(self, error):
        self.progress_bar.set_text(_("Error"))
        for button_ in self.buttons_for_block:
            button_.set_sensitive(True)
        self.button_error.set_visible(True)
        self.button_error.connect("clicked", self.show_error, f"{error}")

    def cli_update_cache(self, stack, package_name, progressbar, error_button,
                         size_label=None, changelogs_label=None):
        try:
            query = create_query("installed", package_name).run()
            if len(query) > 0:
                desktops = []
                for pkg in query:
                    rpms = create_query("available", str(pkg)).run()
                    rpm = rpms[0]
                    def action_with_rpm(*inputs):
                        rpm, extra_rpm = inputs[0], inputs[1]
                        nevra_string = str(rpm)
                        subject = dnf.subject.Subject(nevra_string)
                        possible_nevra = subject.get_nevra_possibilities(
                            forms=[hawkey.FORM_NEVRA, hawkey.FORM_NEVR])
                        po = PackageWrapper(extra_rpm)
                        filelists = po.files
                        if filelists:
                            filelists = filelists.split("\n")
                            for f in filelists:
                                if ".desktop" in f:

                                    NoDisplay = get_artibute_from_desktop(path=f,
                                                                          section="Desktop Entry",
                                                                          setting="NoDisplay")
                                    if NoDisplay == "" or NoDisplay is None:
                                        desktops.append(f)
                        for temp_var, nevra in enumerate(possible_nevra):
                            if nevra.arch != None:
                                DOWNLOAD_SIZE = int(int(getattr(rpm, 'downloadsize')) / 1024)
                                INSTALL_SIZE = int(int(getattr(rpm, 'installsize')) / 1024)
                                CHANGELOGS = build_format_fn(opts_changelogs, rpm)
                                CHANGELOGS = re.sub("'", "`", CHANGELOGS)
                                VERSION = str(nevra.version).strip()
                                RELEASE_VER = str(nevra.release).strip()
                                EPOCH = str(nevra.epoch).strip() if nevra.epoch else None
                                return [DOWNLOAD_SIZE, INSTALL_SIZE, CHANGELOGS, VERSION, RELEASE_VER, EPOCH, desktops]

                    def pass_callback(worker, result, handler_data):
                        DOWNLOAD_SIZE, INSTALL_SIZE, CHANGELOGS, VERSION, RELEASE_VER, EPOCH, desktops = worker.return_value(result)
                        self.changelogs_label.set_text(re.sub("`", "'", CHANGELOGS))
                        if EPOCH:
                            self.size_label.set_text(
                                f"{_('Version')}: {str(EPOCH)}:{str(VERSION)}-{str(RELEASE_VER)}\n"
                                f"{_('Download size')}: {DOWNLOAD_SIZE}Kb\n"
                                f"{_('Full size')}: {INSTALL_SIZE}Kb")
                        else:
                            self.size_label.set_text(f"{_('Version')}: {str(VERSION)}-{str(RELEASE_VER)}\n"
                                                     f"{_('Download size')}: {DOWNLOAD_SIZE}Kb\n"
                                                     f"{_('Full size')}: {INSTALL_SIZE}Kb")
                        if len(desktops) == 1:
                            exec = get_artibute_from_desktop(path=desktops[0], section="Desktop Entry",
                                                             setting="Exec")
                            if exec:
                                self.launch_stack.show()
                                self.launch_stack.set_visible_child_name("page_launch_button")
                                self.launch_stack1.show()
                                self.launch_stack1.set_visible_child_name("page_launch_button")

                                self.launch_button.connect("clicked", self.on_exec_button_clicked, exec)
                                self.launch_button1.connect("clicked", self.on_exec_button_clicked, exec)
                        elif len(desktops) > 1:
                            self.launch_stack.show()
                            self.launch_stack.set_visible_child_name("page_launch_popover")
                            self.launch_stack1.show()
                            self.launch_stack1.set_visible_child_name("page_launch_popover")
                            for desktop in desktops:
                                builder_template_rows = Gtk.Builder()
                                if DEVEL_FLAG:
                                    builder_template_rows.add_from_file('/home/wolandius/git_projects/redos_education/ui/templates.glade')
                                else:
                                    builder_template_rows.add_from_file('/opt/redos_education/ui/templates.glade')

                                grouprow = builder_template_rows.get_object(f"grouprow")
                                if locale.getdefaultlocale()[0] == 'ru_RU':
                                    desktopName = get_artibute_from_desktop(path=desktop, section="Desktop Entry",
                                                                            setting="Name[ru]")
                                    if desktopName == "" or desktopName is None:
                                        desktopName = get_artibute_from_desktop(path=desktop,
                                                                                section="Desktop Entry",
                                                                                setting="Name")
                                else:
                                    desktopName = get_artibute_from_desktop(path=desktop, section="Desktop Entry",
                                                                            setting="Name")
                                exec = get_artibute_from_desktop(path=desktop, section="Desktop Entry",
                                                                 setting="Exec")
                                grouprow.set_name(f"{desktopName}")
                                self.launchmenubox.add(grouprow)
                                more_group_menu = builder_template_rows.get_object("more_group_menu")
                                more_group_menu.set_label(desktopName)
                                more_group_menu.connect("clicked", self.on_exec_button_clicked, exec)
                        create_installed_list()
                        create_updates_list()
                        stack.set_visible_child_name("delete_page")

                    inputs = ([rpm, pkg])
                    async_worker = AsyncWorker(
                        operation=action_with_rpm,
                        operation_inputs=inputs,
                        operation_callback=pass_callback
                    )
                    async_worker.start()
            else:
                create_installed_list()
                create_updates_list()
                stack.set_visible_child_name("install_page")
            return 0
        except Exception as e:
            progressbar.set_text(_("Error"))
            error_button.set_visible(True)
            error_button.connect("clicked", self.show_error, f"{e}")
            return 1

    def show_error(self, button, error):
        win = RedosStoreError()
        win.set_text(error)


    def remove_SIU_childs(self):
        if self.search_stack.get_visible_child_name() == "search_results_page":
            for child in self.search_stack.get_child_by_name("search_results_page"):
                self.search_stack.get_child_by_name("search_results_page").remove(child)
            self.search_stack.remove(self.search_stack.get_child_by_name("search_results_page"))
        if self.installed_stack.get_visible_child_name() == "installed_results_page":
            for child in self.installed_stack.get_child_by_name("installed_results_page"):
                self.installed_stack.get_child_by_name("installed_results_page").remove(child)
            self.installed_stack.remove(self.installed_stack.get_child_by_name("installed_results_page"))
        if self.updates_stack.get_visible_child_name() == "updates_results_page":
            for child in self.updates_stack.get_child_by_name("updates_results_page"):
                self.updates_stack.get_child_by_name("updates_results_page").remove(child)
            self.updates_stack.remove(self.updates_stack.get_child_by_name("updates_results_page"))

    def open_home(self, button):
        if self.page_group and self.app_page and (self.stack.get_visible_child_name() == "search" or
                                                  self.stack.get_visible_child_name() == "installed" or
                                                  self.stack.get_visible_child_name() == "updates"):
            self.blocked_button.set_sensitive(True)
            self.blocked_button = None
            self.sub_stack.remove(self.app_page)
            self.app_page.destroy()
            self.app_page = None
            self.remove_SIU_childs()
            self.back.set_sensitive(True)
            self.search_button.set_sensitive(True)

            if not self.window.is_maximized():
                self.window.resize(900, 700)
        elif self.page_group and (self.stack.get_visible_child_name() == "search" or
                                  self.stack.get_visible_child_name() == "installed" or
                                  self.stack.get_visible_child_name() == "updates"):
            self.blocked_button.set_sensitive(True)
            self.blocked_button = None
            self.stack.set_visible_child(self.page_group)
            self.remove_SIU_childs()
            self.back.set_sensitive(True)
            self.search_button.set_sensitive(True)

            if not self.window.is_maximized():
                self.window.resize(900, 700)
        elif self.app_page and (self.search_stack.get_visible_child_name() == "search_results_page" or
                                self.installed_stack.get_visible_child_name() == "installed_results_page" or
                                self.updates_stack.get_visible_child_name() == "updates_results_page"):
            try:
                self.stack.remove(self.app_page)
            except Exception as e:
                pass
            try:
                self.sub_stack.remove(self.app_page)
            except Exception as e:
                pass
            self.app_page.destroy()
            self.app_page = None
            self.back.set_sensitive(True)
            # self.search_button.set_sensitive(True)

            if self.search_stack.get_visible_child_name() == "search_results_page":
                self.stack.set_visible_child_name("search")
                self.search_stack.set_visible_child_name("search_results_page")
                # self.search_button.set_sensitive(False)
            elif self.installed_stack.get_visible_child_name() == "installed_results_page":
                self.installed_button.clicked()
                self.groupsmenubutton.show()
                self.search_button.set_sensitive(True)

            elif self.updates_stack.get_visible_child_name() == "updates_results_page":
                self.updates_button.clicked()
                self.groupsmenubutton.show()

                self.search_button.set_sensitive(True)
            if not self.window.is_maximized():
                self.window.resize(900, 700)
        elif self.page_group and self.app_page:
            self.sub_stack.set_visible_child(self.sub_main_page)
            self.sub_stack.remove(self.app_page)
            self.app_page.destroy()
            self.search_button.set_sensitive(True)
            self.app_page = None
            if not self.window.is_maximized():
                self.window.resize(900, 700)
            if hasattr(self, 'action_with_app_name'):
                if self.action_with_app_name:
                    for i in range(0, len(self.group_buttons_stacks)):
                        if self.action_with_app_name in self.group_buttons_stacks[i][3]:
                            self.group_buttons_stacks[i][0].set_visible_child_name(self.group_buttons_stacks[i][2])
                            t_stack = self.group_buttons_stacks[i][2]
                            self.group_buttons_stacks[i][2] = self.group_buttons_stacks[i][1]
                            self.group_buttons_stacks[i][1] = t_stack
                            break
            self.action_with_app_name = None

        elif self.stack.get_visible_child_name() == "search" or \
                self.stack.get_visible_child_name() == "installed" or \
                self.stack.get_visible_child_name() == "updates":
            self.remove_SIU_childs()
            self.groupsmenubutton.show()

            self.stack.set_visible_child_name("home")
            self.back.set_sensitive(False)
            self.back.hide()
            self.home.hide()
            self.search_button.set_sensitive(True)
            if not self.window.is_maximized():
                self.window.resize(900, 700)
        elif self.page_group:
            self.stack.set_visible_child_name("home")
            self.stack.remove(self.page_group)
            self.page_group.destroy()
            self.page_group = None
            self.back.set_sensitive(False)
            self.groupsmenubutton.show()

            self.back.hide()
            self.home.hide()
            self.search_button.set_sensitive(True)
            self.blocked_button.set_sensitive(True)
            self.blocked_button = None
            if not self.window.is_maximized():
                self.window.resize(900, 700)
        elif self.app_page:
            self.stack.set_visible_child_name("home")
            self.search_button.set_sensitive(True)
            self.stack.remove(self.app_page)
            self.app_page.destroy()
            self.app_page = None
            self.back.set_sensitive(False)
            self.groupsmenubutton.show()

            self.back.hide()
            self.home.hide()
            if not self.window.is_maximized():
                self.window.resize(900, 700)

class MyException(Exception):
    pass


class RedosStoreError:
    def __init__(self):
        builder_template = Gtk.Builder()
        if DEVEL_FLAG:
            builder_template.add_from_file('/home/wolandius/git_projects/redos_education/ui/templates.glade')
        else:
            builder_template.add_from_file('/opt/redos_education/ui/templates.glade')
        #

        self.window = builder_template.get_object("error_window")
        self.window.set_title(_("Error window"))

        self.window.set_icon_from_file("/opt/redos_education/ui/redos-education32.png")

        self.error_textview = builder_template.get_object("error_textview")

        self.window.set_position(Gtk.WindowPosition.CENTER)
        self.window.show_all()

    def set_text(self, text, stack=None, stack_block=None, buttons_blocked=None, progressbar=None):
        self.error_textview.set_text(text)
        if buttons_blocked:
            for button_ in buttons_blocked:
                button_.set_sensitive(True)
        if stack_block:
            stack_block.set_sensitive(True)
        if stack:
            stack.set_visible_child_name("update_page")
        if progressbar:
            progressbar.set_fraction(0)
            progressbar.set_text("")

    def global_exit(self):
        Gtk.main_quit()

class RedosStoreResolveDeps:
    def __init__(self):
        builder_template = Gtk.Builder()
        if DEVEL_FLAG:
            builder_template.add_from_file('/home/wolandius/git_projects/redos_education/ui/templates.glade')
        else:
            builder_template.add_from_file('/opt/redos_education/ui/templates.glade')
        #

        self.window = builder_template.get_object("resolvedep")
        self.window.set_icon_from_file("/opt/redos_education/ui/redos-education32.png")
        self.window.set_title(_("Resolve dependencies"))
        self.resolvedep_textview = builder_template.get_object("resolve_dep_textview")
        # self.resolvedep_textbuffer = self.resolvedep_textview.get_buffer()

        self.accept_button = builder_template.get_object("accept_transaction")
        self.deny_button = builder_template.get_object("deny_transaction")

        self.window.set_position(Gtk.WindowPosition.CENTER)
        self.window.show_all()

    def close(self, button, buttons_blocked, command, stack, previous_stack=None):
        for button_ in buttons_blocked:
            button_.set_sensitive(True)
        if command == "remove":
            page_name = "delete_page"
        elif command == "install":
            page_name = "install_page"
        elif command == "update":
            page_name = "update_page"
        stack.set_visible_child_name(previous_stack) if previous_stack else stack.set_visible_child_name(page_name)
        stack.set_sensitive(True)

        self.window.destroy()

    def custom_delete(self, window, data, buttons_blocked, command, stack, previous_stack=None):
        for button_ in buttons_blocked:
            button_.set_sensitive(True)
        if command == "remove":
            page_name = "delete_page"
        elif command == "install":
            page_name = "install_page"
        elif command == "update":
            page_name = "update_page"
        stack.set_visible_child_name(previous_stack) if previous_stack else stack.set_visible_child_name(page_name)
        stack.set_sensitive(True)


    def close_upd_all(self, button, stack, stack_block, buttons_blocked, progressbar):
        for button_ in buttons_blocked:
            button_.set_sensitive(True)
        stack_block.set_sensitive(True)
        stack.set_visible_child_name("update_page")
        progressbar.set_fraction(0)
        progressbar.set_text("")
        self.window.destroy()


    def custom_delete_upd_all(self, window, data, stack, stack_block, buttons_blocked, progressbar):
        for button_ in buttons_blocked:
            button_.set_sensitive(True)
        stack_block.set_sensitive(True)
        stack.set_visible_child_name("update_page")
        progressbar.set_fraction(0)
        progressbar.set_text("")
        self.window.destroy()

    def close_group_action(self, button, buttons_blocked, group_buttons_stacks, list_install, list_remove):
        for button_ in buttons_blocked:
            button_.set_sensitive(True)
        # progressbar.set_fraction(0)
        # progressbar.set_text("")
        for stack in group_buttons_stacks:
            stack[0].set_visible_child_name(stack[1])
        list_install.clear()
        list_remove.clear()
        self.window.destroy()

    def custom_delete_group_action(self, window, data, buttons_blocked, group_buttons_stacks, list_install, list_remove):
        for button_ in buttons_blocked:
            button_.set_sensitive(True)
        # progressbar.set_fraction(0)
        # progressbar.set_text("")
        for stack in group_buttons_stacks:
            stack[0].set_visible_child_name(stack[1])
        list_install.clear()
        list_remove.clear()
        self.window.destroy()


    def close_func(self):
        self.window.destroy()

    def set_text(self, text):
        self.resolvedep_textview.set_markup(text)

class InitClass():
    def __init__(self):
        self.window = builder.get_object("inicialize_window")
        self.window.connect("destroy", Gtk.main_quit)
        self.window.show_all()

    def destroy(self):
        self.destroy()

class InfoClass(Gtk.Window):
    def __init__(self):
        Gtk.Window.__init__(self)
        box = Gtk.Box()
        self.add(box)

    def print_info(self, info):
        dialog = Gtk.MessageDialog(self, 0, Gtk.MessageType.INFO,
                                   Gtk.ButtonsType.OK, "Информация")
        dialog.format_secondary_text(info)
        dialog.run()
        dialog.destroy()

    def print_error(self, error):
        dialog = Gtk.MessageDialog(self, 0, Gtk.MessageType.ERROR, Gtk.ButtonsType.CANCEL, "Ошибка")
        dialog.format_secondary_text(error)
        dialog.run()
        dialog.destroy()

    def print_big_error(self, info, widtn, heigth):
        self.liststore = Gtk.ListStore(str)
        self.liststore.append([info])
        dialogWindow = Gtk.MessageDialog(parent=self,
                                         modal=True, destroy_with_parent=True,
                                         message_type=Gtk.MessageType.ERROR,
                                         buttons=Gtk.ButtonsType.OK)
        dialogWindow.set_title(_("Error"))
        dialogWindow.set_resizable(True)
        dialogBox = dialogWindow.get_content_area()

        treeview = Gtk.TreeView(model=self.liststore)
        sel = treeview.get_selection()
        sel.set_mode(Gtk.SelectionMode.NONE)
        renderer_text = Gtk.CellRendererText()
        column_text = Gtk.TreeViewColumn("", renderer_text, text=0)
        treeview.append_column(column_text)

        scrolled_tree = Gtk.ScrolledWindow()
        scrolled_tree.add(treeview)
        dialogWindow.set_size_request(widtn, heigth)
        dialogBox.pack_start(scrolled_tree, True, True, 0)
        dialogWindow.show_all()
        response = dialogWindow.run()
        dialogWindow.destroy()


def custom_delete(window, data):  # действие для подчистки многопоточности, оставляемой приложением
    the_dbus_starter.stop()
    # the_dbus_starter.rules_tmp_firebird()
    Gtk.main_quit()


class AsyncWorker(GObject.Object):
    def __init__(
            self,
            operation=None,
            operation_inputs=(),
            operation_callback=None,
            operation_callback_inputs=(),
            cancellable=None
    ):
        super().__init__()
        self.operation = operation
        self.operation_inputs = operation_inputs
        self.operation_callback = operation_callback
        self.operation_callback_inputs = operation_callback_inputs
        self.cancellable = cancellable
        self.pool = {}

    def start(self):
        task = Gio.Task.new(
            self,
            self.cancellable,
            self.operation_callback,
            self.operation_callback_inputs
        )

        if self.cancellable is None:
            task.set_return_on_cancel(False)  # The task is not cancellable.

        data_id = id(self.operation_inputs)
        self.pool[data_id] = self.operation_inputs
        task.set_task_data(
            data_id,
            lambda key: self.pool.pop(data_id)
        )

        task.run_in_thread(self._thread_callback)

    def _thread_callback(self, task, worker, task_data, cancellable):
        data_id = task.get_task_data()
        data = self.pool.get(data_id)
        outcome = self.operation(*data)
        task.return_value(outcome)

    def return_value(self, result):
        value = ""
        if Gio.Task.is_valid(result, self):
            value = result.propagate_value().value
        else:
            error = "Gio.Task.is_valid returned False."
            value = {"AsyncWorkerError": error}

        return value

def func(*inputs):
    if len(sys.argv) == 1 or (len(sys.argv) == 2 and sys.argv[1] == "--devel"):
        # return 2
        try:
            recreate_dnf_base_query()
            fill_groups()
            create_installed_list()
            create_updates_list()
            return 0
        except Exception as e:
            return [3, e]
    else:
        return 2

def pass_callback(worker, result, handler_data):
    result = worker.return_value(result)
    # os.system("kill -9 $(ps aux | grep '[l]oad_screen.py' | awk '{print $2}')")
    # Gtk.main_quit()
    if result == 0:
        win = RedosStore()
        win.window.connect("delete-event", custom_delete)
        os.system("kill -9 $(ps aux | grep '[l]oad_screen.py' | awk '{print $2}')")
    elif result == 2:
        os.system("kill -9 $(ps aux | grep '[l]oad_screen.py' | awk '{print $2}')")
    elif len(result) == 2:
        if result[0] == 3:
            os.system("kill -9 $(ps aux | grep '[l]oad_screen.py' | awk '{print $2}')")
            win = RedosStoreError()
            text = _("Detected problems with internet connection")
            win.set_text(f'{text}\n\n{result[1]}') \
                if "Cannot download" in str(result[1]) else win.set_text(f"{result[1]}")
            win.window.connect("destroy", Gtk.main_quit)
        else:
            os.system("kill -9 $(ps aux | grep '[l]oad_screen.py' | awk '{print $2}')")


if __name__ == "__main__":
    screen = Gdk.Screen.get_default()
    provider = Gtk.CssProvider()

    if len(sys.argv) > 1:
        if sys.argv[1] == "--devel":
            DEVEL_FLAG = True
    if DEVEL_FLAG:
        gettext.bindtextdomain('redos_education', '/home/wolandius/git_projects/redos_education/ui/locale')
        locale.bindtextdomain("redos_education", "/home/wolandius/git_projects/redos_education/ui/locale")
        builder.add_from_file('/home/wolandius/git_projects/redos_education/ui/redos_education.glade')
        provider.load_from_path("/home/wolandius/git_projects/redos_education/ui/style.css")
    else:
        gettext.bindtextdomain('redos_education', '/opt/redos_education/ui/locale')
        locale.bindtextdomain("redos_education", "/opt/redos_education/ui/locale")
        builder.add_from_file('/opt/redos_education/ui/redos_education.glade')
        provider.load_from_path("/opt/redos_education/ui/style.css")

    Gtk.StyleContext.add_provider_for_screen(screen, provider, Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION)
    inputs = ()
    async_worker = AsyncWorker(
        operation=func,
        operation_inputs=inputs,
        operation_callback=pass_callback
    )
    async_worker.start()
    Gtk.main()
